'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . SQLite methods
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . SQlite API usage
' . String and BSTR usage
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Simple script helper to create a SQLite db file from a CSV file
'//////////////////////////////////////////////////////////////////////////////
Dim separator  : separator = ";"
Const dbTable      = "DataTable"
Const SCRIPTEZ_API = "ScriptEZ.API" ' Component name
Const VERSION      = "CSV To SQLite Parser v1.4 | "

Dim batchMode
Dim ScriptEZ
Dim hSQLite
Dim dbFilename  : dbFilename = ""
Dim entete      : entete = ""
' start the script
'////////////////
'On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()
    batchMode = true
    Set WshShell = CreateObject("WScript.Shell")
    Set fso = CreateObject("Scripting.FileSystemObject")  ' Create file system object
    Set objArgs  = WScript.Arguments 
    Set fileCollection = CreateObject("Scripting.Dictionary")

    'On Error Resume Next
    hSQLite      = 0

    ' instantiate component object with callback interface
    Set ScriptEZ = CreateObject(SCRIPTEZ_API)
    ScriptEZ.SetCPUCoreAffinity "1"
    ScriptEZ.SetCPUCoreAffinity "PRIORITY_HIGH:0"
    Dim matchedfiles
    Dim a ' Declare an array
    matchedfiles = 0   
    Dim fileSize

    If matchedfiles <= 0  Then
        logfile = ScriptEZ.GetOpenDlgFileName("CSV File (*.txt)|*.txt|CSV File (*.csv)|*.csv", "Opening...", 95)
        If Len(logfile) > 0 then
            Set rf   = fso.OpenTextFile(logfile, 1, false) ' open for reading
            elems    = Split(logfile,"\")
            fileCollection.Add elems(UBound(elems)),logfile
            dbFilename =  logfile + ".sqlite"

            If fso.FileExists(dbFilename + "-journal") Then fso.DeleteFile(dbFilename + "-journal")
           
            If fso.FileExists(logfile) = false Then Exit Sub

            Set f    = fso.GetFile(logfile)
            ' Reading log file for inserting into SQLite data base
            Set rf = fso.OpenTextFile(logfile, 1, false) ' open for reading
            entete = rf.ReadLine
            r = ScriptEZ.FindString(entete, separator) 'search for ';' as separator
            If r <= 0 Then
                If ScriptEZ.FindString(entete, vbTab) >= 1 Then
                    separator = vbTab ' <tab> is the separator
                Else
                    ScriptEZ = Nothing
                    f = Nothing
                    rf.Close()
                    Exit Sub
                End If
            End If
            
            Set f = Nothing
            rf.Close
           
            hSQLite = ScriptEZ.CreateSQLiteDBObject(dbFilename)
            hdr_fields = Split(entete+separator,separator)
            createTable = "CREATE TABLE " & dbTable & "(["+ hdr_fields(0) + "] Text"
            For i=1 To UBound(hdr_fields)-1
              createTable = createTable + ", [" + hdr_fields(i) + "] Text"
            Next

            ScriptEZ.Echo("Please, wait a moment...")
            ScriptEZ.CenterWindow(-1)
            
            createTable = createTable + ");"
            n = ScriptEZ.SQLite_execDML(hSQLite, createTable)
            WScript.Sleep 3000

            ' block until end of SQL create table
            Do Until Not fso.FileExists(dbFilename + "-journal")
              WScript.Sleep 1000
            Loop

            hStringValueTable = ScriptEZ.MallocStringTable(UBound(hdr_fields)) ' table
        Else
            Set ScriptEZ = Nothing
            Set fso = Nothing
            Exit Sub
        End if
    End If

    Dim timeStart : timeStart = ScriptEZ.GetTimeStampEx(0)
    Dim date_log : date_log = ""
    numline = 0
    Set a = Nothing
    a = fileCollection.Items   ' Get file items on which to iterate

    For Each logfile In a
        If fso.FileExists(logfile) = false Then Exit For

        Set f    = fso.GetFile(logfile)
        fileSize = f.size
        ' Reading log file for inserting into SQLite data base
        Set rf = fso.OpenTextFile(logfile, 1, false) ' open for reading
        ScriptEZ.Echo "file: " + logfile
        Dim nlines : nlines = 0
        Dim bulkInsert : bulkInsert =""
        logfeed = rf.ReadLine

        Do While rf.AtEndOfStream <> True
            numline = numline +1
            logfeed = rf.ReadLine +separator
            ScriptEZ.SetConsoleTitle VERSION + "Reading line #" + CStr(numline) + " | Used RAM: " + CStr(ScriptEZ.ProbeMemoryStatus(7)) + " KBytes"

            log_infos = Split(logfeed,separator) ' separator
            For k=0 To UBound(log_infos)-1
             r = ScriptEZ.ReplaceStringTableItemAt(hStringValueTable,log_infos(k), k)
            Next
           
            nlines = nlines + 1
            insertSQL = ScriptEZ.SQLite_buildInsertCommand(dbTable,hStringValueTable)
            bulkInsert = bulkInsert + insertSQL
            If nlines Mod 360 = 0 Then
              r = ScriptEZ.SQLite_execDML(hSQLite,bulkInsert)
              bulkInsert = ""
              nlines = 0
            End If
            ScriptEZ.FreeBSTR insertSQL
           resetSQLiteTableValue(hStringValueTable)
        Loop

        ScriptEZ.SetSQLiteDBObjectCommitTimeout hSQLite,0
        If nlines > 0 Then
            r = ScriptEZ.SQLite_execDML(hSQLite, bulkInsert)
            WScript.Sleep 3000
        End If
        Set f = Nothing
        rf.Close
    Next
           

    ' block until end of SQL inserting
    Do Until Not fso.FileExists(dbFilename + "-journal")
        WScript.Sleep 1000
    Loop

    ScriptEZ.DestroySQLiteDBObject hSQLite
    Dim timeStop : timeStop = ScriptEZ.GetTimeStampEx(0)
    Dim timeDiff : timeDiff = ScriptEZ.GetTimeDiff(timeStop,timeStart)
    r = ScriptEZ.PopupMsgBox("Done, take time (" & timeDiff & ")",0)

    Set ScriptEZ = Nothing
    Set fso = Nothing

End Sub

Function resetSQLiteTableValue(hStringValueTable)
    Dim numElements, i
    numElements = ScriptEZ.GetStringTableItemCount(hStringValueTable)
    For i = 0 to numElements-1
        r = ScriptEZ.ReplaceStringTableItemAt(hStringValueTable, "", i)
    Next
End Function