using System;
using System.Threading;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using SCRIPTEZLib;
namespace ConsoleApp
{
    class Program
    {
        public static SCRIPTEZLib.API scriptEZ;
        public static COMEventSink comSink;
        public static System.Runtime.InteropServices.ComTypes.IConnectionPoint icp;
        public static int cookie;
        public static bool exitApp = false;
        public static int[] task_exec_counter = new int[7];

        // Multi-threaded context....
        [MTAThread]
        static void Main(string[] args)
        {
            Thread oThread = new Thread(new ThreadStart(ThreadStart));
            oThread.SetApartmentState(ApartmentState.MTA);
            oThread.Start();

            while (!exitApp)
            {
               /// Yielding control
               Thread.Sleep(10);
            }

            if (comSink.watchDogProcessID > 0)
            {
               scriptEZ.Terminate(comSink.watchDogProcessID);
            }

            // 4. Uninstall COM Event Sink
            icp.Unadvise(cookie);

            oThread.Abort();
        }
        /// <summary>
        /// .NET thread procedure
        /// </summary>
        public static void ThreadStart()
        { 
           /// Instantiating the COMponent object
           scriptEZ = new SCRIPTEZLib.API();
           if (scriptEZ != null)
           {
               /// Mapping affinity to CPU Core1
               scriptEZ.SetCPUCoreAffinity("0");

               /// Just an echo
               scriptEZ.Echo("Who said...that COM became \"has been\" ?!");

               /// Setup Remote Control Interface
               scriptEZ.AppRegister("");

               /// Instantiating and setting up the COM Event Sink (callback)
               comSink = new COMEventSink();
               comSink.scriptEZ = scriptEZ;

               System.Runtime.InteropServices.ComTypes.IConnectionPointContainer icpc;
               // 1. Search for Connection point container
               icpc = (System.Runtime.InteropServices.ComTypes.IConnectionPointContainer)scriptEZ;
               
               Guid IID_IAPIEvents = typeof(_IAPIEvents).GUID;
               // 2. Search for a Connection point
               icpc.FindConnectionPoint(ref IID_IAPIEvents, out icp);
               // 3. Handshaking COM Event Sink with the Connection point
               icp.Advise(comSink, out cookie);

               /// Create a pool of 4 threads for executing 8 jobs
               int threadPool = scriptEZ.get_CreateTaskQueueObject(4);

               // A task for displaying memory status on the Title bar
               scriptEZ.get_AddTask(threadPool, 2); 
            
               // Seven demoing Tasks : passing a class pointer, encode/decode char buffer of timestamp
               for (int i = 1; i <= 7; i++)
               {
                   TaskParams taskParams = new TaskParams();
                   taskParams.id = i; // Task#i
                   // Object to IntPtr (memory pointer)
                   GCHandle handle = GCHandle.Alloc(taskParams);
                   IntPtr   ptr = (IntPtr)handle;
                   taskParams.pointer = ptr.ToString("x");

                   byte[] byteArray;
                   byteArray = Encoding.Default.GetBytes(DateTime.Now.ToLongDateString()+" "+
                                                         DateTime.Now.ToLongTimeString()+"."+
                                                         DateTime.Now.Millisecond.ToString());
                   taskParams.sizeOfChars = byteArray.Length;

                   // Convert Byte Array to IntPtr (memory pointer)
                   taskParams.pinnedArray = GCHandle.Alloc(byteArray, GCHandleType.Pinned);
                   taskParams.ptrChars = taskParams.pinnedArray.AddrOfPinnedObject();
                   // Encode data chunk into memory with random address of 'taskParams'
                   scriptEZ.EncryptString((int)taskParams.ptrChars, taskParams.sizeOfChars, taskParams.pointer);

                   // Push this task into the threadpool...
                   scriptEZ.get_AddTask(threadPool, (int)ptr);
               }
           }
        }
    }

    class TaskParams
    {
        public long     id;
        public string   pointer;
        public GCHandle pinnedArray;
        public IntPtr   ptrChars;
        public int      sizeOfChars;
    }
    /// <summary>
    /// Implementing _IAPIEvents callback interface (early binding)
    /// Note that all functions must be declared and defined, even though NOT USED.
    /// </summary>
    class COMEventSink : _IAPIEvents
    {
        public int watchDogProcessID = 0;
        
        public SCRIPTEZLib.API scriptEZ;
        public string AppEventHelp()
        {
            string task_exec = "Tasks execution counter:\n";
            for (int i = 0; i < 7; i++)
            {
                task_exec = task_exec + " .TaskID " + (i+1).ToString()  + 
                            " executed " + Program.task_exec_counter[i].ToString() + " times\n";
            }

            return "Welcome in a COM World !\n<Enter>\n" +
                   " -9 to exit gracefully the program\n" +
                   "  8 to enable auto-restart feature\n" +
                   (watchDogProcessID > 0 ? "\nWatchdog Process ID: " + watchDogProcessID.ToString():"") + "\n" +
                   task_exec;
        }

        public void onAppEvent(int EventID)
        {
            switch (EventID)
            {
                case -9: Program.exitApp = true; 
                         break;
                case 8 : if(watchDogProcessID == 0) watchDogProcessID = scriptEZ.get_AppAutoRestart(""); 
                         break;
                default: break;
            }
        }

        public void onAbort(int appID)
        {
        }

        public int onConnectionRequest(int hSocketClientObjectProxy)
        {
            return 0;
        }

        public int onConnectionRequestNamedPipe(int hNamedPipeClientObjectProxy)
        {
            return 0;
        }

        public int onConnectionState(int hOwnerSocket, string state_desc, int error_number)
        {
            System.Console.Write(state_desc + ":" + error_number.ToString() );
            return 0;
        }

        public int onConnectionStateNamedPipe(int hOwnerNamedPipe, string state_desc, int error_number)
        {
            System.Console.Write(state_desc + ":" + error_number.ToString());
            return 0;
        }

        public int onData(int hOwnerSocket, int raw_data, int data_size)
        {
            return 0;
        }

        public int onDataNamedPipe(int hOwnerNamedPipe, int raw_data, int data_size)
        {
            return 0;
        }

        public int onEndOfSlideShow(int hPlayList)
        {
            return 0;
        }

        public int onRun(int task_local_storage)
        {
            // a little pause
            scriptEZ.Sleep(300);
            if (task_local_storage == 2)
            {
                int currentProcessID = scriptEZ.GetCurrentProcessId;
                int ram = (scriptEZ.get_ProbeMemoryStatus(currentProcessID));
                scriptEZ.SetConsoleTitle("Own used memory: " + ram.ToString() +
                                         " Bytes | Thread number: " + scriptEZ.get_ProbeMemoryStatus(-4) +
                                         " | Open Handle number: " + scriptEZ.get_ProbeMemoryStatus(-7));
            }
            else
            {
                // back IntPtr to object (in callback function)
                GCHandle handle = (GCHandle)(IntPtr)task_local_storage;
                TaskParams taskParams = (handle.Target as TaskParams);
                // if no more need, free it now => if return 0 from this task
                // handle.Free();

                Program.task_exec_counter[taskParams.id - 1]++;
                if (taskParams.sizeOfChars > 0)
                {
                    // Decode data chunk from memory with address of 'taskParams'
                    scriptEZ.EncryptString((int)taskParams.ptrChars, taskParams.sizeOfChars, taskParams.pointer);
                    taskParams.sizeOfChars = 0;
                    // if no more need, free it now => if return 0 from this task
                    // taskParams.pinnedArray.Free();

                }
#if false
                string timeStamp = scriptEZ.get_ConvertStringToBSTR((int)taskParams.ptrChars);
#else
                byte[] byteArray = taskParams.pinnedArray.Target as byte[];
                string timeStamp = Encoding.Default.GetString(byteArray,0, byteArray.Length);
#endif
                System.Console.WriteLine(" TaskID: " + taskParams.id +
                                         ", Timestamp: " + timeStamp +
                                         ", Object pointer: x" + taskParams.pointer +
                                         ", Pooled Thread ID: " + scriptEZ.GetCurrentPooledThreadId +
                                         (task_local_storage == 2 ? " (Who said that COM has been ?!)" : ""));
            }
            return 1; // need to run again
        }

        public int onServerDocData(int DataRows, int RowCount, int DataSize)
        {
            return 0;
        }

        public int onServerDocStatus(int Status)
        {
            return 0;
        }

        public int onSlideShowBGColor(string SlideShow)
        {
            return 0;
        }

        public int onTimer(int IDTimerEvent)
        {
            return 0;
        }

    }
}
