﻿Option Explicit Off
Module ModuleMain

    'Option Explicit
    Const SCRIPTEZ_API = "ScriptEZ.API" ' Component name
    Const VERSION_HTTP = "Simple Http Downloader - version 2.7"
    Const VERSION_FTP = "Simple Ftp Downloader - version 2.7"
    Const VERSION_BOTH = "Simple Http/Ftp Downloader - version 2.7"
    Dim fso
    Dim localFilename
    Dim ftpFileSize
    Dim ftpFile
    Dim verbose
    Dim hwndFlash
    Dim hWndAlerter
    Dim withResume

    '-------------------------------------
    Public WithEvents ScriptEZMain As SCRIPTEZLib.API
    ' Fetch command line options
    '////////////////
    Function GetCommandLine(ByRef n As Long, Optional MaxArgs As Long = 10) As Array

        'Declare variables.
        Dim C, cmdLine, CmdLnLen, InArg, i, NumArgs
        'See if MaxArgs was provided.
        'If IsMissing(MaxArgs) Then MaxArgs = 10

        'Make array of the correct size.
        ReDim ArgArray(MaxArgs)
        NumArgs = 0 : InArg = False
        'Get command line arguments.
        cmdLine = Command()
        CmdLnLen = Len(cmdLine)
        'Go thru command line one character
        'at a time.
        Dim doubleQuote : doubleQuote = 0
        For i = 1 To CmdLnLen
            C = Mid(cmdLine, i, 1)
            If C = Chr(34) Then doubleQuote = doubleQuote + 1
            'Test for space or tab.
            If (C <> " " And C <> vbTab) Or (doubleQuote > 0 And doubleQuote < 2) Then
                'Neither space nor tab.
                'Test if already in argument.
                If Not InArg Then
                    'New argument begins.
                    'Test for too many arguments.
                    If NumArgs = MaxArgs Then Exit For
                    NumArgs = NumArgs + 1
                    InArg = True
                End If
                'Concatenate character to current argument.
                ArgArray(NumArgs) = ArgArray(NumArgs) & Replace(C, Chr(34), "")
            Else
                'Found a space or tab.
                'Set InArg flag to False.
                InArg = False
                doubleQuote = 0
            End If
        Next i
        If NumArgs > 0 Then
            'Resize array just enough to hold arguments.
            ReDim Preserve ArgArray(NumArgs)
            'Return Array in Function name.
            GetCommandLine = ArgArray
        Else
            GetCommandLine = Nothing
        End If
        n = NumArgs

    End Function
    ' Main entry
    '////////////////
    Sub Main()

        Dim url, RemoteFilename
        Dim r As Long
        withResume = ""
        verbose = 1
        offset = 3
        isRegFree = 0
        isTest = 0
        TestLabel = ""
        objArgs = GetCommandLine(r, 10)
        rArgCount = r
        If r > 0 Then
            For i = 1 To r
                If objArgs(i) = "/gui" Then verbose = 0
                If objArgs(i) = "/nogui" Then verbose = -1
                If objArgs(i) = "/test" Then
                    isTest = 1
                    TestLabel = " (simulating)"
                End If
            Next
        End If

        If (r < 2) Then
            On Error Resume Next
            MsgBox("Oops !" + vbLf + vbLf + _
                   "Available command line syntaxes:" + vbLf + _
                   "1. HttpDownload <HttpFtp/Filename> <LocalFullFilename>" + vbLf + _
                   "2. HttpDownload <HttpFtp> <FullFilename> <LocalFullFilename>" + vbLf + vbLf + _
                   "For example," + vbLf + "downloading " + _
                    Chr(34) + "http://usite.com/obj.zip or ftp://usite.com/obj.zip" + Chr(34) + vbLf + _
                   "file can be entered with one of the following syntaxes:" + vbLf + vbLf + _
                   "1) HttpDownload http://usite.com/obj.zip c:\tmp\obj.zip" + vbLf + _
                   "2) HttpDownload http://usite.com /obj.zip c:\tmp\obj.zip" + vbLf + _
                   "3) HttpDownload http://usite.com /obj.zip c:\tmp\obj.zip /gui" + vbLf + _
                   "4) HttpDownload http://usite.com /obj.zip c:\tmp\obj.zip /nogui" + vbLf + _
                   "5) HttpDownload ftp://usite.com/obj.zip c:\tmp\obj.zip" + vbLf + _
                   "6) HttpDownload ftp://usite.com /obj.zip c:\tmp\obj.zip" + vbLf + _
                   "7) HttpDownload ftp://usite.com /obj.zip c:\tmp\obj.zip /gui" + vbLf + _
                   "8) HttpDownload ftp://usite.com /obj.zip c:\tmp\obj.zip /nogui" + vbLf, _
                   vbInformation, _
                   VERSION_BOTH)
            Exit Sub
        End If

        fso = CreateObject("Scripting.FileSystemObject")
        dict = CreateObject("Scripting.Dictionary")
        For i = 1 To rArgCount
            If objArgs(i) <> "/gui" And _
               objArgs(i) <> "/nogui" And _
               objArgs(i) <> "/test" Then
                dict.Add(objArgs(i), objArgs(i))
            End If
        Next
        objArgs = dict.Items

        Dim protocol_http
        protocol_http = 1
        ' case 1: complete URL
        If UBound(objArgs) = 1 Then
            pos = InStr(objArgs(0), "//")
            If pos = 7 Or pos = 6 Or pos = 5 Then
                url = Mid(objArgs(0), pos + 2, Len(objArgs(0)) - pos)
                pos2 = InStr(url, "/")
                RemoteFilename = Mid(url, pos2, Len(objArgs(0)) - (pos2 - 1))
                If pos = 6 Then
                    url = "http://" + Mid(url, 1, pos2 - 1) ' The Http is used
                ElseIf pos = 7 Then
                    url = "https://" + Mid(url, 1, pos2 - 1) ' The Https is used
                Else
                    url = "ftp://" + Mid(url, 1, pos2 - 1) ' The Ftp is used
                    protocol_http = 0
                End If
            Else
                pos = InStr(objArgs(0), "/")
                RemoteFilename = Mid(objArgs(0), pos, Len(objArgs(0)) - (pos - 1))
                url = Mid(objArgs(0), 1, pos - 1)
            End If
            localFilename = objArgs(1)
        ElseIf UBound(objArgs) >= 2 Then
            ' case 2: separated website and remotefilename
            url = objArgs(0)
            RemoteFilename = objArgs(1)
            localFilename = objArgs(2)
            If InStr(url, "ftp://") = 1 Then protocol_http = 0 ' The Ftp is used
        End If

        ScriptEZMain = New SCRIPTEZLib.API
        If ScriptEZMain Is Nothing Then
            MsgBox("Please, download and register " + SCRIPTEZ_API + _
                    " component from http://sovann.googlepages.com and try again...", vbInformation, VERSION_HTTP)
            Exit Sub
        End If


        If verbose = 1 Then ScriptEZMain.ClearConsole()
        ScriptEZMain.SetCPUCoreAffinity("0")
        ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
        ScriptEZMain.AppRegister()

        Dim Slash, hBinaryFile : hBinaryFile = 0
        Dim fSize : fSize = 0
        If protocol_http = 1 Then
            ' http file reading....
            If fso.FileExists(localFilename) Then
                zFile = fso.GetFile(localFilename)
                fSize = zFile.Size
                zFile = Nothing
                httpFileHandle = ScriptEZMain.OpenHttpFileAt(url, AnsiToHtml(RemoteFilename), CStr(fSize))
                withResume = " (with resume)"
            Else
                httpFileHandle = ScriptEZMain.OpenHttpFile(url, AnsiToHtml(RemoteFilename))
            End If

            If httpFileHandle <= 0 Then
                ScriptEZMain.AppUnregister()
                ScriptEZMain = Nothing
                Exit Sub
            End If

            r = ScriptEZMain.HttpReadFile(httpFileHandle)
            If r = 1 Then

                Dim ret, rawData, readBytes, readTotalBytes
                Dim fileSize
                fileSize = 0
                If Len(localFilename) > 0 Then
                    If isTest = 0 Then
                        hBinaryFile = ScriptEZMain.OpenBinaryFile(localFilename)
                    Else
                        hBinaryFile = 1
                    End If
                    If fSize > 0 And isTest = 0 Then r = ScriptEZMain.SetBinaryFileHugePos(hBinaryFile, CStr(fSize))

                    If hBinaryFile > 0 Then
                        startTime = ScriptEZMain.GetTimeStampEx(1)
                        If ScriptEZMain.ProbeMemoryStatus(-2) >= 2298 Then
                            fileSize = ScriptEZMain.HttpReadFile(-httpFileHandle) ' get this file size in Bytes or KBytes
                            If fileSize > 0 Then fileSize = fileSize + (fSize / 1024)
                        End If
                        rawData = ScriptEZMain.HttpGetReadBufferAsBinary(httpFileHandle)
                        readBytes = ScriptEZMain.HttpGetReadBytes(httpFileHandle)
                        readTotalBytes = fSize + readBytes

                        If verbose = 1 Then
                            ScriptEZMain.Echo(vbLf + VERSION_HTTP + withResume + vbLf + ". Writing into: " + localFilename + TestLabel)
                        ElseIf verbose = 0 Then
                            hwndFlash = ScriptEZMain.CreateFlashWindow(0, " " + vbLf + "Estimating time...")
                            hTooltip = ScriptEZMain.CreateTooltipWindow(hwndFlash)
                            ScriptEZMain.EnableTopmostWindow(hwndFlash)
                            hWndAlerter = ScriptEZMain.GetDlgItem(hwndFlash, 1002)
                            r = ScriptEZMain.SetWindowText(hWndAlerter, "Writing into " + localFilename + TestLabel)
                            r = ScriptEZMain.AddTooltipWindowText(hTooltip, hWndAlerter, VERSION_HTTP + withResume + " | from " + objArgs(0) + Slash + objArgs(1))
                            ScriptEZMain.ShowWindow(hWndAlerter)
                        End If

                        Slash = ""
                        If InStr(objArgs(1), "/") <> 1 Then Slash = "/" ' Cosmetic displaying !!
                        Dim TotalSize : TotalSize = fSize / 1024
                        Dim TotalDeltaReadBytes : TotalDeltaReadBytes = 0
                        Dim topSeconds : topSeconds = ScriptEZMain.GetTimeStampEx
                        Dim remaining : remaining = ""
                        Dim bandWidth : bandWidth = 0.0#

                        Dim remoteFilesize : remoteFilesize = fileSize
                        If remoteFilesize > 0 Then
                            remoteFilesize = remoteFilesize * 1024
                        Else
                            remoteFilesize = -remoteFilesize
                        End If

                        Do Until readBytes <= 0
                            System.Windows.Forms.Application.DoEvents()
                            If fileSize > 0 And verbose = 1 Then
                                ScriptEZMain.SetConsoleTitle(CStr(FormatNumber(readTotalBytes / 1024, 0, 0, -2)) +
                                                             " / " + CStr(FormatNumber(fileSize, 0, 0, -2)) +
                                                             " (" + CStr(Fix((TotalSize / fileSize) * 100)) + "%) KBytes read from " +
                                                             objArgs(0) + Slash + objArgs(1))
                            ElseIf fileSize < 0 And verbose = 1 Then
                                ScriptEZMain.SetConsoleTitle(CStr(FormatNumber(readTotalBytes / 1024, 0, 0, -2)) +
                                                             " / " + CStr(Math.Abs(fileSize)) + " Bytes read from " + objArgs(0) + Slash + objArgs(1))
                            ElseIf verbose = 1 Then
                                ScriptEZMain.SetConsoleTitle(CStr(FormatNumber(readTotalBytes / 1024, 0, 0, -2)) +
                                                             " KBytes read from " + objArgs(0) + Slash + objArgs(1))
                            End If

                            If verbose = 0 And fileSize > 0 Then
                                Threading.Thread.Sleep(100) '-- yielding for displaying info
                                r = ScriptEZMain.SetWindowText(hwndFlash,
                                                               " " + CStr(FormatNumber(readTotalBytes / 1024, 0, 0, -2)) +
                                                               " / " + CStr(FormatNumber(fileSize, 0, 0, -2)) +
                                                               " (" + CStr(Fix((TotalSize / fileSize) * 100)) + "%) KBytes downloaded")
                                hWndAlerter = ScriptEZMain.GetDlgItem(hwndFlash, 1003)
                                If bandWidth > 0 Then r = ScriptEZMain.SetWindowText(hWndAlerter, "Estimated remaining time: " + remaining + " | " + Replace(CStr(bandWidth), ",", ".") + " Kbps")
                            End If
                            If isTest = 0 Then ret = ScriptEZMain.WriteBinaryFile(hBinaryFile, rawData, readBytes)

                            r = ScriptEZMain.HttpReadFile(httpFileHandle)
                            rawData = ScriptEZMain.HttpGetReadBufferAsBinary(httpFileHandle)
                            readBytes = ScriptEZMain.HttpGetReadBytes(httpFileHandle)
                            TotalDeltaReadBytes = TotalDeltaReadBytes + readBytes
                            If readBytes > 1024 Then TotalSize = TotalSize + (readBytes / 1024)

                            If readBytes = 0 And verbose = 1 Then
                                endTime = ScriptEZMain.GetTimeStampEx(1)
                                ScriptEZMain.Echo(vbLf + ". Download succeeded (" + CStr(FormatNumber(readTotalBytes / 1024, 0, 0, -2)) + " KBytes read)")
                                ScriptEZMain.Echo(vbLf + ". Taken time  : " + ScriptEZMain.GetTimeDiff(endTime, startTime) + " (hh:mn:ss.mss)")
                            Else
                                readTotalBytes = readTotalBytes + readBytes
                                Top = ScriptEZMain.GetTimeStampEx
                                deltaSec = ScriptEZMain.GetTimeDiff(Top, topSeconds)
                                delta = CLng(Replace(Replace(deltaSec, ":", ""), ".", ""))
                                ScriptEZMain.FreeBSTR(deltaSec)
                                ScriptEZMain.FreeBSTR(Top)
                                '00:00:10.000 => 10000
                                If delta >= 10000 Then
                                    bandWidth = CDbl(TotalDeltaReadBytes * 8 / 1024 / 10)
                                    remaining = "Unavailable, since unknown remote file size"
                                    If fileSize > 0 Then
                                        remainingKbytes = fileSize - readTotalBytes / 1024
                                        remaining_seconds = (remainingKbytes * 8) / bandWidth

                                        hh = CLng(remaining_seconds / 3600)
                                        remaining_seconds = CLng(remaining_seconds Mod 3600)
                                        mn = CLng(remaining_seconds / 60)
                                        ss = CLng(remaining_seconds Mod 60)
                                        remaining = CStr(hh) + "h:" + CStr(mn) + "mn:" + CStr(ss) + "s"
                                    End If
                                    If verbose = 1 Then
                                        ScriptEZMain.ClearConsole()
                                        ScriptEZMain.Echo(vbLf + VERSION_HTTP + withResume + vbLf + ". Writing into: " + localFilename + TestLabel)
                                        ScriptEZMain.Echo(vbLf + ". Estimated remaining time: " + remaining + " | " + Replace(CStr(bandWidth), ",", ".") + " Kbps")
                                    End If
                                    TotalDeltaReadBytes = 0
                                    ScriptEZMain.FreeBSTR(topSeconds)
                                    topSeconds = ScriptEZMain.GetTimeStampEx
                                End If

                            End If
                        Loop

                        If readBytes > 0 And isTest = 0 Then
                            ret = ScriptEZMain.WriteBinaryFile(hBinaryFile, rawData, readBytes)
                        End If

                        If verbose = 0 Then r = ScriptEZMain.DestroyWindow(hwndFlash)

                    Else
                        If verbose >= 0 Then MsgBox("Creating local file " + localFilename + " failed !", vbExclamation, VERSION_HTTP)
                    End If
                End If
            End If
            If isTest = 0 Then ScriptEZMain.CloseBinaryFile(hBinaryFile)
            ScriptEZMain.CloseHttpFile(httpFileHandle)
        Else
            '/// ftp download
            hFtpConnection = ScriptEZMain.OpenFtpConnection(url, "", "")
            If hFtpConnection > 0 Then
                If verbose = 1 Then
                    ScriptEZMain.Echo(vbLf + VERSION_FTP + vbLf + ". Writing into: " + localFilename)
                ElseIf verbose = 0 Then
                    hwndFlash = ScriptEZMain.CreateFlashWindow(0, "_")
                    hTooltip = ScriptEZMain.CreateTooltipWindow(hwndFlash)
                    ScriptEZMain.EnableTopmostWindow(hwndFlash)
                    hWndAlerter = ScriptEZMain.GetDlgItem(hwndFlash, 1002)
                    ScriptEZMain.HideWindow(hWndAlerter)
                    r = ScriptEZMain.SetWindowText(hWndAlerter, "Writing into " + localFilename)
                    r = ScriptEZMain.AddTooltipWindowText(hTooltip, hWndAlerter, VERSION_FTP + " | from " + objArgs(0) + Slash + objArgs(1))
                    ScriptEZMain.ShowWindow(hWndAlerter)
                End If
                hThreadPool = ScriptEZMain.CreateTaskQueueObject(1)
                r = ScriptEZMain.AddTask(hThreadPool, 5000)
                ' get remote file size from Ftp Server
                ftpFileSize = ScriptEZMain.FtpDownloadFile(hFtpConnection, RemoteFilename, "")
                If (ftpFileSize < 0) Then
                    ' file size is over 4 GBytes
                    hugeSize = ScriptEZMain.FtpFileSize(hFtpConnection, RemoteFilename)
                    ftpFileSize = CDbl(hugeSize)
                    ScriptEZMain.FreeBSTR(hugeSize)
                End If
                ' call and block till end
                r = ScriptEZMain.FtpDownloadFile(hFtpConnection, RemoteFilename, localFilename)
                ScriptEZMain.CloseFtpConnection(hFtpConnection)
                If r = 1 And verbose = 1 Then
                    ScriptEZMain.Echo(vbLf + "ftp downloading succeeded...")
                ElseIf verbose = 1 Then
                    ScriptEZMain.Echo(vbLf + "ftp downloading failed...")
                ElseIf verbose = 0 Then
                    r = ScriptEZMain.DestroyWindow(hwndFlash)
                End If
            End If
        End If
        ' App unregister before ending
        ScriptEZMain.AppUnregister()
        Threading.Thread.Sleep(500)
        ScriptEZMain = Nothing
    End Sub

    Function ScriptEZMain_onRun(timeout) As Integer Handles ScriptEZMain.onRun

        Threading.Thread.Sleep(timeout)

        ' check whether local file is already created
        If Not fso.FileExists(localFilename) Then
            ScriptEZMain_onRun = CLng(1)
            Exit Function
        End If

        If ftpFile Is Nothing Then
            ' create object once
            ftpFile = fso.GetFile(localFilename)
        End If
        fileSize = ftpFile.Size
        If ftpFileSize > 0 And verbose = 1 Then
            ScriptEZMain.SetConsoleTitle("FTP downloading in progress: " +
                                         CStr(FormatNumber(fileSize / 1024, 0, 0, -2)) + "/" +
                                         CStr(FormatNumber(ftpFileSize / 1024, 0, 0, -2)) + " (" +
                                         CStr(Fix((fileSize / ftpFileSize) * 100)) + "%) KBytes downloaded")
        ElseIf ftpFileSize > 0 And verbose = 0 Then
            Threading.Thread.Sleep(10) '-- yielding for displaying info
            r = ScriptEZMain.SetWindowText(hwndFlash,
                                           CStr(FormatNumber(fileSize / 1024, 0, 0, -2)) + "/" +
                                           CStr(FormatNumber(ftpFileSize / 1024, 0, 0, -2)) + " (" +
                                           CStr(Fix((fileSize / ftpFileSize) * 100)) + "%) KBytes downloaded")
        End If
        ScriptEZMain_onRun = CLng(1)

    End Function

    Function AnsiToHtml(url) As String
        AnsiToHtml = Replace(url, Chr(224), Chr(195) + Chr(160))       '-- à
        AnsiToHtml = Replace(AnsiToHtml, Chr(225), Chr(195) + Chr(161)) '-- á
        AnsiToHtml = Replace(AnsiToHtml, Chr(226), Chr(195) + Chr(162)) '-- â
        AnsiToHtml = Replace(AnsiToHtml, Chr(227), Chr(195) + Chr(163)) '-- ã
        AnsiToHtml = Replace(AnsiToHtml, Chr(228), Chr(195) + Chr(164)) '-- ä
        AnsiToHtml = Replace(AnsiToHtml, Chr(229), Chr(195) + Chr(165)) '-- å
        AnsiToHtml = Replace(AnsiToHtml, Chr(230), Chr(195) + Chr(166)) '-- æ
        AnsiToHtml = Replace(AnsiToHtml, Chr(231), Chr(195) + Chr(167)) '-- ç
        AnsiToHtml = Replace(AnsiToHtml, Chr(232), Chr(195) + Chr(168)) '-- è
        AnsiToHtml = Replace(AnsiToHtml, Chr(233), Chr(195) + Chr(169)) '-- é
        AnsiToHtml = Replace(AnsiToHtml, Chr(234), Chr(195) + Chr(170)) '-- ê
        AnsiToHtml = Replace(AnsiToHtml, Chr(235), Chr(195) + Chr(171)) '-- ë
        AnsiToHtml = Replace(AnsiToHtml, Chr(236), Chr(195) + Chr(172)) '-- ì
        AnsiToHtml = Replace(AnsiToHtml, Chr(237), Chr(195) + Chr(173)) '-- í
        AnsiToHtml = Replace(AnsiToHtml, Chr(238), Chr(195) + Chr(174)) '-- î
        AnsiToHtml = Replace(AnsiToHtml, Chr(239), Chr(195) + Chr(175)) '-- ï
        AnsiToHtml = Replace(AnsiToHtml, Chr(240), Chr(195) + Chr(176)) '-- ð
        AnsiToHtml = Replace(AnsiToHtml, Chr(241), Chr(195) + Chr(177)) '-- ñ
        AnsiToHtml = Replace(AnsiToHtml, Chr(242), Chr(195) + Chr(178)) '-- ò
        AnsiToHtml = Replace(AnsiToHtml, Chr(243), Chr(195) + Chr(179)) '-- ó
        AnsiToHtml = Replace(AnsiToHtml, Chr(244), Chr(195) + Chr(180)) '-- ô
        AnsiToHtml = Replace(AnsiToHtml, Chr(245), Chr(195) + Chr(181)) '-- õ
        AnsiToHtml = Replace(AnsiToHtml, Chr(246), Chr(195) + Chr(182)) '-- ö
        AnsiToHtml = Replace(AnsiToHtml, Chr(247), Chr(195) + Chr(183)) '-- ÷
        AnsiToHtml = Replace(AnsiToHtml, Chr(248), Chr(195) + Chr(184)) '-- ø
        AnsiToHtml = Replace(AnsiToHtml, Chr(249), Chr(195) + Chr(185)) '-- ù
        AnsiToHtml = Replace(AnsiToHtml, Chr(250), Chr(195) + Chr(186)) '-- ú
        AnsiToHtml = Replace(AnsiToHtml, Chr(251), Chr(195) + Chr(187)) '-- û
        AnsiToHtml = Replace(AnsiToHtml, Chr(252), Chr(195) + Chr(188)) '-- ü
        AnsiToHtml = Replace(AnsiToHtml, Chr(253), Chr(195) + Chr(189)) '-- ý
        AnsiToHtml = Replace(AnsiToHtml, Chr(254), Chr(195) + Chr(190)) '-- þ
        AnsiToHtml = Replace(AnsiToHtml, Chr(255), Chr(195) + Chr(191)) '-- ÿ
        AnsiToHtml = Replace(AnsiToHtml, Chr(196), Chr(195) + Chr(132)) '-- Ä
        AnsiToHtml = Replace(AnsiToHtml, Chr(194), Chr(195) + Chr(130)) '-- Â
        AnsiToHtml = Replace(AnsiToHtml, Chr(199), Chr(195) + Chr(135)) '-- Ç
        AnsiToHtml = Replace(AnsiToHtml, Chr(202), Chr(195) + Chr(138)) '-- Ê
        AnsiToHtml = Replace(AnsiToHtml, Chr(203), Chr(195) + Chr(139)) '-- Ë
        AnsiToHtml = Replace(AnsiToHtml, Chr(206), Chr(195) + Chr(142)) '-- Î
        AnsiToHtml = Replace(AnsiToHtml, Chr(207), Chr(195) + Chr(143)) '-- Ï
        AnsiToHtml = Replace(AnsiToHtml, Chr(212), Chr(195) + Chr(148)) '-- Ô
        AnsiToHtml = Replace(AnsiToHtml, Chr(214), Chr(195) + Chr(150)) '-- Ö
        AnsiToHtml = Replace(AnsiToHtml, Chr(219), Chr(195) + Chr(155)) '-- Û
        AnsiToHtml = Replace(AnsiToHtml, Chr(220), Chr(195) + Chr(156)) '-- Ü
    End Function

End Module
