﻿'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Copyright 2011
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . Connect, query for SQL data flow from within ServerDoc App 
' . Threadpool usage
' . Echo() method usage which displays always messages into a console window
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Client connecting and posting queries for Perf Counters  
'//////////////////////////////////////////////////////////////////////////////
Public Class Form1

    ' global variables
    Dim WithEvents ScriptEZObject As SCRIPTEZLib.API = Nothing
    Dim HostAndPort()
    Dim timerId = 0
    Dim typeEnc

    ' Start connection
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim r, hStringTable, InputString

        If timerId <= 0 Then
            ' connect to server
            hStringTable = ScriptEZObject.MallocStringTable(3)
            r = ScriptEZObject.AddStringTableItem(hStringTable, "localhost:8088:ServerDoc")
            r = ScriptEZObject.AddStringTableItem(hStringTable, "localhost:8088:ServerDoc for Mobile")
            r = ScriptEZObject.AddStringTableItem(hStringTable, "195.154.101.34:8088:ServerDoc for Mobile")
            '-- Tip: negativate handle of the parent window avoid crashing this app
            InputString = ScriptEZObject.InputComboBox(-Me.Handle.ToInt32, "Enter your hostname and port, such like localhost:8088", hStringTable)
            ScriptEZObject.FreeStringTable(hStringTable)
            If InputString = vbNullString Then
                Exit Sub
            End If

            HostAndPort = Split(InputString, ":")
            If HostAndPort(2) = "ServerDoc for Mobile" Then RadioButton3.Checked = True


            If RadioButton1.Checked Then
                    r = ScriptEZObject.ServerDocConnect(HostAndPort(0), HostAndPort(1))
                    typeEnc = -1
                ElseIf RadioButton2.Checked Then
                    r = ScriptEZObject.ServerDocConnect(HostAndPort(0), HostAndPort(1), 64)
                    typeEnc = 64
                ElseIf RadioButton3.Checked Then
                    r = ScriptEZObject.ServerDocConnect(HostAndPort(0), HostAndPort(1), 0)
                    typeEnc = 0
                End If
                If r <> 0 Then
                    RichTextBox1.Text = "Connection failed"
                Else
                    ' Restore Formp previous positions on the Desktop
                    r = ScriptEZObject.RestoreWindowLayout(Me.Handle, HostAndPort(0) + ":" + HostAndPort(1))
                End If

            Else
                ' disconnect from server
                If MsgBox("Disconnect now ?", MsgBoxStyle.Question Or MsgBoxStyle.YesNo) = vbYes Then
                ScriptEZObject_onAppEvent(4)
            End If
        End If

    End Sub
    ' Release inner objects/memory and componet
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim r
        If timerId Then
            r = ScriptEZObject.SaveWindowLayout(Me.Handle, HostAndPort(0) + ":" + HostAndPort(1))
            r = ScriptEZObject.KillTimer(timerId)
        End If
        ScriptEZObject.AppUnregister()
        ScriptEZObject = Nothing

    End Sub
    ' Form loadEvent: instantiating component
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ScriptEZObject = New SCRIPTEZLib.API
        ScriptEZObject.AppRegister()
        Dim menuItem1 As New MenuItem()
        menuItem1.Text = "This Process ID is: " + CStr(ScriptEZObject.GetCurrentProcessId()) + _
                         " | Active Threads: " + CStr(ScriptEZObject.ProbeMemoryStatus(-4))
        Dim mainMnu As New MainMenu()
        mainMnu.MenuItems.Add(menuItem1)
        Menu = mainMnu
        RichTextBox1.Tag = RichTextBox1.ForeColor
      End Sub
    ' Remoting Control Interface: Callback to provide Help/Self Doc
    Private Function ScriptEZObject_AppEventHelp() As String Handles ScriptEZObject.AppEventHelp

        ScriptEZObject_AppEventHelp = CStr("Available AppEventIDs, please <Enter>:" + vbLf + vbLf + _
                                      " <3> to Exit App" + vbLf + _
                                      " <4> to Disconnect from ServerDoc")
    End Function
    ' Remoting Control Interface: Callback to deal with an AppEvent
    Private Sub ScriptEZObject_onAppEvent(ByVal EventID As Integer) Handles ScriptEZObject.onAppEvent

        If EventID = 3 Then
            Me.Close()
        ElseIf EventID = 4 Then
            timerId = ScriptEZObject.KillTimer(timerId)
            timerId = ScriptEZObject.ServerDocDisconnect()
            Button1.Text = "Connect to ServerDoc..."
            RadioButton1.Enabled = True
            RadioButton2.Enabled = True
            RadioButton3.Enabled = True
            MaskedTextBox1.ReadOnly = False
            Me.Text = ".NET / ScriptEZ.API - disconnected from [" + HostAndPort(0) + ":" + HostAndPort(1) + "]"
            RichTextBox1.Text = ""
            RichTextBox1.ForeColor = RichTextBox1.Tag
        End If

    End Sub
    ' ServerDoc App Status: Connected/Disconnected or Reconnected
    Private Function ScriptEZObject_onServerDocStatus(ByVal Status As Integer) As Integer Handles ScriptEZObject.onServerDocStatus

        Dim r
        If Status = 0 Then
            ' selecting known fields for a SQL table
            Dim selected_fields = "DATE,SERVER_TIME,IN_USE_MEMORY,OWN_MEMORY,PENDING_TASKS," + _
                                  "SEND,RECV,RECV_MAX,RECV_MIN,QUERY_COUNT,QUERY_FAILURE,UPDATE_COUNT," + _
                                  "INCOMING_REQUEST,IP_LIMIT,WHITE_IP,BLOCKED_IP,COM_APARTMENT"
            r = ScriptEZObject.ServerDocPostSQLFields(selected_fields)
            timerId = ScriptEZObject.SetTimer(Min6(CLng(MaskedTextBox1.Text)) * 1000)
            MaskedTextBox1.ReadOnly = True
            Button1.Text = "Disconnect..."
            'GroupBox1.Enabled = False
            If RadioButton1.Checked Then
                RadioButton2.Enabled = False
                RadioButton3.Enabled = False
            ElseIf RadioButton2.Checked Then
                RadioButton1.Enabled = False
                RadioButton3.Enabled = False
            ElseIf RadioButton3.Checked Then
                RadioButton1.Enabled = False
                RadioButton2.Enabled = False
            End If
            Me.Text = ".NET / ScriptEZ.API - connected at [" + HostAndPort(0) + ":" + HostAndPort(1) + "]"
            RichTextBox1.Text = "Performance Counters will be soon displayed..."
        Else
            Me.Text = ".NET / ScriptEZ.API - disconnected from [" + HostAndPort(0) + ":" + HostAndPort(1) + "]"
            timerId = ScriptEZObject.KillTimer(timerId)
            timerId = 0
        End If
        ScriptEZObject_onServerDocStatus = CLng(0)

    End Function
    ' ServerDoc App Data Flow
    Private Function ScriptEZObject_onServerDocData(ByVal DataRows As Integer, ByVal RowCount As Integer, ByVal DataSize As Integer) As Integer Handles ScriptEZObject.onServerDocData

        Dim bstrData
        Dim bstrArray
        Dim encryptLabel = ""
        If RowCount > 0 Then
            bstrData = ScriptEZObject.ConvertStringToBSTR(DataRows)
            If bstrData <> Nothing Then
                bstrArray = Split(bstrData, vbTab)
                Select Case typeEnc
                    Case 0
                        encryptLabel = "none (simple 10 bytes header)"
                    Case -1
                        encryptLabel = "full (recommended)"
                    Case 64
                        encryptLabel = "along with 64 bytes (custom)"
                End Select
                bstrData = " Refresh delay....: " + CStr(Min6(CLng(MaskedTextBox1.Text)) * 1000 / 1000) + " seconds" + vbCrLf +
                          " ." + vbCrLf +
                          " DATE.............: " + bstrArray(0) + vbCrLf +
                          " SERVER_TIME......: " + bstrArray(1) + vbCrLf +
                          " IN_USE_MEMORY....: " + bstrArray(2) + vbCrLf +
                          " OWN_MEMORY.......: " + bstrArray(3) + vbCrLf +
                          " PENDING_TASKS....: " + bstrArray(4) + vbCrLf +
                          " SEND.............: " + bstrArray(5) + vbCrLf +
                          " RECV.............: " + bstrArray(6) + vbCrLf +
                          " RECV_MAX.........: " + bstrArray(7) + vbCrLf +
                          " RECV_MIN.........: " + bstrArray(8) + vbCrLf +
                          " QUERY_COUNT......: " + bstrArray(9) + vbCrLf +
                          " QUERY_FAILURE....: " + bstrArray(10) + vbCrLf +
                          " UPDATE_COUNT.....: " + bstrArray(11) + vbCrLf +
                          " INCOMING_REQUEST.: " + bstrArray(12) + vbCrLf +
                          " IP_LIMIT.........: " + bstrArray(13) + vbCrLf +
                          " WHITE_IP.........: " + bstrArray(14) + vbCrLf +
                          " BLOCKED_IP.......: " + bstrArray(15) + vbCrLf +
                          " COM_APARTMENT....: " + bstrArray(16) + vbCrLf +
                          " ." + vbCrLf +
                          " Encryption type..: " + encryptLabel

                If CLng(Mid(bstrArray(2), 1, 2)) > NumericUpDown1.Value Then
                    RichTextBox1.ForeColor = Color.Yellow
                Else
                    RichTextBox1.ForeColor = RichTextBox1.Tag
                End If

                RichTextBox1.Text = bstrData
                ' free memory block
                ScriptEZObject.FreeString(DataRows)
                Menu.MenuItems(0).Text = "This Process ID is: " + CStr(ScriptEZObject.GetCurrentProcessId()) + _
                                         " | Active Threads: " + CStr(ScriptEZObject.ProbeMemoryStatus(-4)) + _
                                         " | Own Memory In Use: " + Replace(FormatNumber(ScriptEZObject.ProbeMemoryStatus(7) / 1024, 2, , , TriState.True), ",", ".") + " KBytes" + _
                                         " | Reconnection count: " + CStr(ScriptEZObject.ProbeMemoryStatus(-1))
            End If
        End If
        ScriptEZObject_onServerDocData = CLng(0)

    End Function
    ' Timer: Callback for TimerEvent after SetTimer is called
    Private Function ScriptEZObject_onTimer(ByVal IDTimerEvent As Integer) As Integer Handles ScriptEZObject.onTimer

        Dim QueryCommandString
        Dim currDate, r

        currDate = FormatDateTime(Microsoft.VisualBasic.DateAndTime.Now(), DateFormat.ShortDate)
        QueryCommandString = "SELECT * FROM PERF_COUNT WHERE DATE='" + currDate + "';"
        ' Instead of a full path filename, ":memory:" is a special name for Perf counters
        r = ScriptEZObject.ServerDocPostSQLQuery(QueryCommandString, ":memory:")
        ScriptEZObject_onTimer = CLng(0)

    End Function
    ' Inner function to limit min delay at 6 seconds
    Private Function Min6(ByVal a As Long) As Long

        If a > 6 Then
            Min6 = a
        ElseIf a <= 6 Then
            Min6 = 6
            MaskedTextBox1.Text = "06"
        End If

    End Function
End Class
