'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . File + Directory stuff
' . File reading from http site
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Testing 
'//////////////////////////////////////////////////////////////////////////////
const URL          = "http://sites.google.com"
const HTTPFILE     = "/site/sovannpub/home/ScriptEZ_API.zip"

const SCRIPTEZ_API = "ScriptEZ.API" ' Component name
Dim ScriptEZMain
Dim onExit 

' start the script
'/////////////////
'On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  onExit       = 0
  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  '-- if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If
  
  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZMain_")
  If Not IsObject(ScriptEZMain) Then Exit Sub

  'ScriptEZMain.SetCPUCoreAffinity "0"
 
  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZMain.AppRegister
  ScriptEZMain.SetConsoleTitle "Demo Http File Reading"

  ' Demo http file reading....
  httpFileHandle = ScriptEZMain.OpenHttpFile(URL,HTTPFILE)
  
  r = ScriptEZMain.HttpReadFile(httpFileHandle)
  If r = 1 Then
    nbRead = 1
    bsRet = ScriptEZMain.GetSaveDlgFileName("Tous (*.*)|*.*", "Save As File Dialog - ScriptEZ_API.zip", 95)
    if Len(bsRet) > 0 then 
     hBinaryFile = ScriptEZMain.OpenBinaryFile(bsRet)
     ScriptEZMain.FreeBSTR bsRet
     rawData = ScriptEZMain.HttpGetReadBufferAsBinary(httpFileHandle)
     readBytes = ScriptEZMain.HttpGetReadBytes(httpFileHandle)
     readTotalBytes = readBytes
     Do Until readBytes <= 0 
        ScriptEZMain.SetConsoleTitle "Demo Http File Reading (" + CStr(nbRead) + ")" 
        ScriptEZMain.Echo ". " + URL + "/" + HTTPFILE + " " + CStr(readBytes) + " byte(s)"
        ret = ScriptEZMain.WriteBinaryFile(hBinaryFile,rawData,readBytes) 
            
        r = ScriptEZMain.HttpReadFile(httpFileHandle)
        rawData = ScriptEZMain.HttpGetReadBufferAsBinary(httpFileHandle)
        readBytes = ScriptEZMain.HttpGetReadBytes(httpFileHandle)
        If readBytes = 0 Then
           ScriptEZMain.Echo ". Fin de copie avec succs ! (" + CStr(readTotalBytes) + ") bytes remotely read"
        Else
           nbRead = nbRead + 1
           readTotalBytes = readTotalBytes + readBytes
        End If
     Loop
    End if
  End If
  ScriptEZMain.CloseBinaryFile(hBinaryFile)
  ScriptEZMain.CloseHttpFile httpFileHandle


  ' block until socket break or exit event
  Do Until onExit = 3
      WScript.Sleep 1000
  Loop

  ' App unregister before ending
  ScriptEZMain.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZMain = Nothing

End Sub

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZMain_onAppEvent(EventID)

 ScriptEZMain.Echo " -> EventID:" + CStr(EventID)
 Select Case EventID
   Case 3  onExit= 3
 End Select

End Sub

Function ScriptEZMain_AppEventHelp()

 ScriptEZMain_AppEventHelp = vbLF +_
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF +_
       "AppEventID = 3" + vbTab + "to exit" + vbLF _
       )

End Function
