'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . TCP/IP usage
' . Encryption
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Simple TCP/IP Client to remote copying a video file
'//////////////////////////////////////////////////////////////////////////////

const destination_file = "C:\Temp\Faune.avi"
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name

Dim ScriptEZMain
Dim hSocketClient
Dim Err_num
Dim onExit 
Dim InputString
Dim hFileBinary2
Dim realSize
' start the script
'/////////////////
Main()

' Main Subroutine
'////////////////
Sub Main()

  Dim HostAndPort

  onExit       = 0
  realSize     = 0

  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If
  
  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZMain_")
  ScriptEZMain.SetCPUCoreAffinity "0"

  ' create client socket object
  hSocketClient = ScriptEZMain.CreateSocketClientObjectEx
  'no encryption: ScriptEZMain.EnableSocketObjectDataEncryption hSocketClient,true,-1 

  ' connect to server
  InputString = InputBox("Enter your hostname and port, such like localhost:12349", _
                         "Choose a hostname", _
                         "localhost:12349")
  If Len(InputString) <= 0 Then Exit Sub
  HostAndPort = Split(InputString,":")
  
  If fso.FileExists(destination_file) Then fso.DeleteFile(destination_file)
  hFileBinary2 = ScriptEZMain.OpenBinaryFile(destination_file)

  Err_num  = ScriptEZMain.ConnectSocketServerObject(HostAndPort(0), HostAndPort(1), hSocketClient)
  If Err_num <> 0 Then Exit Sub
  
  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZMain.AppRegister
  ScriptEZMain.SetConsoleTitle " - File Copy Client " + InputString  

  
  ' block until socket break or exit event
  Do Until Err_num <> 0  Or onExit = 3
      WScript.Sleep 10000
      bandwidth = ScriptEZMain.GetSocketObjectInOutBoundBandwidth(hSocketClient)
      bandwidth = Split(bandwidth,"|")
      ScriptEZMain.SetConsoleTitle "FileCopy@" + InputString  + " | me " + _ 
                                   bandwidth(0) + " (in) | remote " + bandwidth(3) + " (out), used RAM: " + CStr(ScriptEZMain.ProbeMemoryStatus(7)) + " KBytes"
  Loop

  ' App unregister before ending
  ScriptEZMain.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZMain = Nothing

End Sub

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZMain_onAppEvent(EventID)
 ScriptEZMain.Echo " -> EventID:" + CStr(EventID)
 Select Case EventID
   Case 3  onExit= 3
 End Select
End Sub

Function ScriptEZMain_AppEventHelp()

 ScriptEZMain_AppEventHelp = vbLF +_
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF +_
       "AppEventID = 3" + vbTab + "to exit" + vbLF )
End Function


' Callbacks for socket object 
' ( client/proxy side)
'///////////////////////////
Function ScriptEZMain_onConnectionState(hOwnerSocket,state_desc,error_number)

  ScriptEZMain.Echo state_desc
  Err_num =  error_number
  r = ScriptEZMain.EnableSocketObjectInOutBoundBandwidthPolling(hOwnerSocket)
  ScriptEZMain_onConnectionState = CLng(0)

End Function 

' ( client/proxy side)
'//////////////////////////
Function ScriptEZMain_onData(hOwnerSocket,raw_data,data_size)

  ' converting string to BSTR
  Dim bstrData
  bstrData   = ScriptEZMain.ConvertStringToBSTR(raw_data)
  If Len(bstrData) <= 0 Then 
     ScriptEZMain.Echo "No memory at all !"
	 ScriptEZMain_onData = CLng(-1) ' let component free chunk of data: 'raw_data'
	 Exit Function
  End If
  If data_size = 5 And Len(bstrData) Then 
     ' getting first the real size of binary data: realSize
     realSize   = CLng(bstrData)
     ScriptEZMain_onData = CLng(-1) ' let component free chunk of data: 'raw_data'
     ScriptEZMain.FreeBSTR bstrData
     If realSize > 0 Then Exit Function
  End If 
 
  If realSize > 0 Then
    pNewData = ScriptEZMain.BSTRToBinary(bstrData)
    r = ScriptEZMain.WriteBinaryFile(hFileBinary2,pNewData,realSize)
    ScriptEZMain.FreeString pNewData
    ScriptEZMain.FreeBSTR bstrData
    realSize = 0
  Else
    ScriptEZMain.CloseBinaryFile hFileBinary2
    onExit = 3
  End If
  ScriptEZMain_onData = CLng(-1) ' let component free chunk of data: 'raw_data' 

End Function 
