'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . TCP/IP usage + auto-reconnection (every 12 seconds)
' . Threadpool usage
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Simple TCP/IP Client Sending PC Stats every 8 seconds (default) to a server 
'//////////////////////////////////////////////////////////////////////////////
const SCRIPTEZ_API      = "ScriptEZ.API" ' Component name
const PROBING_DELAY_LBL = "PROBING_DELAY:"
const AGENT_VERSION     = "2.23"

Dim WshShell
Dim WshNetwork
Dim ScriptEZMain
Dim ScriptEZConnect
Dim hSocketClient
Dim ReplyCount
Dim StartTime
Dim TotalRecv
Dim TotalSend
Dim LastRecvTime
Dim Err_num
Dim hThreadPool
Dim onExit 
Dim InputString
Dim showRecvData
Dim Resend
Dim ScrollOutput
Dim PendingTasks
Dim Socket_ver
Dim bstrData
Dim HostAndPort
Dim probing_delay
' start the script
'/////////////////
On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  probing_delay = 5000
  Err_num = 0
  ScrollOutput = 1
  Resend       = 0
  showRecvData = 1
  onExit       = 0
  ReplyCount = 0
  hSocketClient = 0
  TotalRecv  = 0

  StartTime = Now()
  LastRecvTime = Now()
  
  Set WshShell = CreateObject("WScript.Shell")
  Set WshNetwork = WScript.CreateObject("WScript.Network")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If
  
  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZMain_")
  'ScriptEZMain.SetCPUCoreAffinity "0"

  ' creating thread pool with 1 threads for reconnecting
  hThreadPool = ScriptEZMain.CreateTaskQueueObject(1)

  ' connect to server
  hStringTable = ScriptEZMain.MallocStringTable(3)
  r = ScriptEZMain.AddStringTableItem(hStringTable,"localhost:12348")
  r = ScriptEZMain.AddStringTableItem(hStringTable,"localhost:12345")
  r = ScriptEZMain.AddStringTableItem(hStringTable,"localhost:80")
  InputString = ScriptEZMain.InputComboBox(0,"Enter your hostname and port, such like localhost:12348",hStringTable)
  If Len(InputString) <= 0 Then Exit Sub
  ScriptEZMain.FreeStringTable hStringTable

  HostAndPort = Split(InputString,":")

  Set ScriptEZConnect = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZConnect_")
  ' create client socket object + xtra encryption
  hSocketClient = ScriptEZConnect.CreateSocketClientObjectEx
  Socket_ver = ScriptEZConnect.GetSocketObjectVersion(hSocketClient) 
  ScriptEZConnect.EnableSocketObjectDataEncryption hSocketClient,true,-1 

  r  = ScriptEZConnect.ConnectSocketServerObject(HostAndPort(0), HostAndPort(1), hSocketClient)
  ScriptEZMain.Echo "Connection state: " & CStr(r) & ", go ahead ! auto-reconnecting till server is up..."

 ' Since ScriptEZ.API version 2.16, no need to use this code on client-side
 ' If Err_num <> 0 Then
 '     r = ScriptEZMain.AddTask( hThreadPool, 0 ) ' Re-attempting to reconnect...later
 ' End If

 
  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZConnect.AppRegister

  ' block until socket break or exit event
  Do Until onExit = 3
      WScript.Sleep 1000
  Loop

  ' empty queued msg for sending
  r = ScriptEZConnect.SendSocketObjectData(hSocketClient,vbNullString,0)

  ' App unregister before ending
  ScriptEZConnect.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZConnect = Nothing
  Set ScriptEZMain = Nothing
  Set WshShell = Nothing
  Set WshNetwork = Nothing

End Sub

Function DataHandler()

 Dim data_size, pos
 data_size  = Len(bstrData)
 pos = InStr(1,bstrData,PROBING_DELAY_LBL)
 If pos > 0 Then 
   probing_delay = CLng(Mid(bstrData,15))
   ScriptEZMain.Echo "New probing delay (ms) from server: " & CStr(probing_delay)
 Else
   If showRecvData = 1 Then ScriptEZMain.Echo CStr(Now)  + " size(" + CStr(data_size) + "):  - server's time " + CStr(bstrData)
 End If
 DataHandler = 0 

End Function

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZConnect_onAppEvent(EventID)

 ScriptEZMain.Echo " -> EventID:" + CStr(EventID)
 Select Case EventID
   Case 3  onExit= 3
   Case 0  showRecvData = 0
   Case 1  showRecvData = 1
   Case 2  Resend    = 0
   Case 4  Resend    = 1
   Case 5  ScrollOutput = 0
   Case 6  ScrollOutput = 1
 End Select

End Sub

Function ScriptEZConnect_AppEventHelp()

 ScriptEZConnect_AppEventHelp = vbLF +_
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF +_
       "AppEventID = 0" + vbTab + "to hide received data (default)" + vbLF +_
       "AppEventID = 2" + vbTab + "to not resend back data (default)" + vbLF +_
       "AppEventID = 6" + vbTab + "to enable scrolling (default)" + vbLF +_
       "AppEventID = 1" + vbTab + "to display received data" + vbLF +_
       "AppEventID = 4" + vbTab + "to start resending back data" + vbLF + _
       "AppEventID = 5" + vbTab + "to disable scrolling" + vbLF +_
       "AppEventID = 3" + vbTab + "to exit" + vbLF _
       )

End Function


' Callbacks for socket object 
' ( client/proxy side)
'///////////////////////////
Function ScriptEZConnect_onConnectionState(hOwnerSocket,state_desc,error_number)

  Dim code_err
  code_err = CStr(error_number)
  If error_number = 0 Then
    hSocketClient = hOwnerSocket ' refresh his global variable in case of auto-reconnection
    Err_num = 0
	'r = ScriptEZMain.EnableSocketObjectNonBlockingModeUsage(hOwnerSocket,1)
    r = ScriptEZMain.AddTask( hThreadPool, hSocketClient )
  End If
  ScriptEZConnect_onConnectionState = CLng(0)
  ScriptEZMain.Echo state_desc + " (" + code_err + ")"

End Function 

' ( client/proxy side)
'//////////////////////////
Function ScriptEZConnect_onData(hOwnerSocket,raw_data,data_size)

  ' converting string to BSTR
  bstrData   = ScriptEZMain.ConvertStringToBSTR(raw_data)
  LastRecvTime = Now()
  TotalRecv = TotalRecv + data_size

  If showRecvData = 0 Then
    ScriptEZMain.Echo " ThreadID:" + CStr(ScriptEZMain.GetCurrentThreadId) +_
                      vbTab +" Data size..:" + CStr(data_size)
  End If
  
  ' Handle this packet of data
  r = DataHandler()

  ScriptEZMain.FreeBSTR bstrData
  ScriptEZMain.FreeString raw_data
  ScriptEZConnect_onData = CLng(0)

End Function 

' Notification on Task aborting
'//////////////////////////////
Sub ScriptEZMain_onAbort( lpString )
End Sub

' Callback for thread pool object (TaskQueueObject)
'//////////////////////////////////////////////////
Function ScriptEZMain_onRun( localStorage )

  Dim zDate, zMonth, zDay, zClient
  zDate = Date()
  zMonth = CStr(Month(zDate))
  If Len(zMonth) < 2 Then zMonth = "0" +zMonth
  zDay = CStr(Day(zDate))
  If Len(zDay) < 2 Then zDay = "0" +zDay

  hSocket = localStorage
  strComputer = "."  
  On Error Resume Next
  Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")
  
  ' -- Structure of messages to send:	
	' (0) Computername 
	' (1) username 
	' (2) Memory + CPU usage 
	' (3) Physical memory 
	' (4) Free physical memory 
	' (5) Free virtual memory 
	' (6) Last reboot time + OS name 
	' (7) Number of - Processes + Services + Threads -  
	' (8) Refresh date + Failover counter 
	' (9) Network adapters 
	' (10) Drives spaces 
	' (11) Version of script agent 

 ' --- Case where no WMI layer (begining of block)
  If IsObject(objWMIService) = false Then

 	TestData = "(!) No WMI service, upgrading Windows required !" + vbLF + _  
	            "n.a" + " - inactive:" + CStr(Fix(ScriptEZMain.GetCurrentSessionUserInactivity/60)) + " mn" + vbLF + _ 
				CStr(ScriptEZMain.ProbeMemoryStatus(0)) + "% - CPU:n.a% - me (" + _
			         FormatNumber(ScriptEZMain.ProbeMemoryStatus(7),0,0,-2) +  " Kbytes) / n.a" + vbLF + _
 				CStr(ScriptEZMain.ProbeMemoryStatus(1))+ vbLF + _ 
				CStr(ScriptEZMain.ProbeMemoryStatus(2))+ vbLF + _ 
				CStr(ScriptEZMain.ProbeMemoryStatus(6))+ vbLF + _ 
				"n.a"+ vbLF + _ 
				"n.a"+ vbLF + _ 
				CStr(Year(zDate))+zMonth+zDay+ " - " + CStr(ScriptEZMain.ProbeMemoryStatus(-1)) + vbLF + _ 
				"n.a"+ vbLF + _ 
				ChkDriveSpace()+ vbLF + _ 
				AGENT_VERSION 

    ' Begin to send info array to remote server...				
	r =ScriptEZConnect.SendSocketObjectData( hSocket,TestData, Len(TestData) )
	WScript.Sleep probing_delay
    If onExit = 3 Then
     ScriptEZMain_onRun = CLng(0) ' stop this task
     ScriptEZMain.Echo "Exit thread pool..."
	Else
	 ScriptEZMain_onRun = CLng(1) 
	 DisplayInfo()
    End If	
    Exit Function
  End If
 ' --- Case where no WMI layer (end of block)

  If onExit = 3 Then
    ScriptEZMain_onRun = CLng(0) ' stop this task
    ScriptEZMain.Echo "Exit thread pool..."
    Exit Function
  Else
    ScriptEZMain_onRun = CLng(1) ' run again this task
	Set colItems = objWMIService.ExecQuery("Select * from Win32_Process",,48)
	MaxWorkingSetSize = 0
	For Each objItem in colItems
	  If CLng(objItem.WorkingSetSize) > MaxWorkingSetSize Then
		HiMemProcess = "PID:" + CStr(objItem.ProcessID) + " " + CStr(objItem.Caption)
		MaxWorkingSetSize = CLng(objItem.WorkingSetSize)
	  End If 
	Next
	Set colItems = Nothing
	'ScriptEZMain.Echo HiMemProcess + " (" + CStr(Fix(MaxWorkingSetSize/1024)) + " Kbytes)"
  End If
 
  WScript.Sleep probing_delay
  Dim hSocket
  Dim Total

  ' Since ScriptEZ.API version 2.16, no need to use this code on client-side
  'If localStorage = 0 Then 
  '     ScriptEZMain_onRun = CLng(0) 
  '     Err_num  = ScriptEZConnect.ConnectSocketServerObject(HostAndPort(0), HostAndPort(1), hSocketClient)
  '     If Err_num <> 0 Then
  '       ScriptEZMain.Echo "Auto-reconnecting in 5 seconds..."
  '       r = ScriptEZMain.AddTask( hThreadPool, 0 )
  '     Else   
  '       ScriptEZMain.Echo "Reconnection done..."
  '       r = ScriptEZMain.AddTask( hThreadPool, hSocketClient )
  '     End If
  '     Exit Function
  'End If

' Send statistics about the current PC
' ====================================
  Dim szCPU, CPULoad
  Set colItems = objWMIService.ExecQuery("Select * from Win32_Processor",,48)
  For Each objItem in colItems
    szCPU  = "\" & CStr(objItem.Name)
    If Len(objItem.LoadPercentage) > 0 Then
      CPULoad=  CStr(objItem.LoadPercentage)
    Else
      CPULoad= "0"
    End If
  Next
  Set colItems = Nothing
  If Len(szCPU) <= 0 Then szCPU ="?"
  If Len(CPULoad) <= 0 Then CPULoad ="?"
  Set WshSysEnv = WshShell.Environment("SYSTEM")
  szCPU = szCPU + " - CORE#: " + WshSysEnv("NUMBER_OF_PROCESSORS")
  Set WshSysEnv = Nothing 
  
  Set colItems = objWMIService.ExecQuery("Select * from Win32_ComputerSystem",,48)
  For Each objItem in colItems

    If Len(objItem.UserName) > 0 Then
      Usernames=Split(objItem.UserName,"\") 
    Else
	  If IsObject(WshNetwork) Then
        Usernames=Split("localhost\"+WshNetwork.UserName,"\")
	  Else
	    Usernames=Split("localhost\?","\")
	  End If
    End If
	Usernames(1) =  Usernames(1) + " - inactive:" + CStr(Fix(ScriptEZMain.GetCurrentSessionUserInactivity/60)) + " mn"

    If Len(objItem.Manufacturer) > 0 And Len(objItem.Model) > 0 Then
       TestData = CStr(objItem.Name) &  " [" & Trim(CStr(objItem.Manufacturer)) & "_" & Trim(CStr(objItem.Model)) & "]" + szCPU + vbLF + CStr(Usernames(1)) + vbLF
    Else
       TestData = CStr(objItem.Name) &  " [N/a_N/a]" + szCPU +vbLF + CStr(Usernames(1)) + vbLF
    End If
  Next
  Set colItems = Nothing
     
  TestData = TestData + _
             CStr(ScriptEZMain.ProbeMemoryStatus(0)) + "% - CPU: " + CPULoad + "% - me (" + _
			     FormatNumber(ScriptEZMain.ProbeMemoryStatus(7),0,0,-2) +  " Kbytes) / " + _
				 HiMemProcess + " (" + CStr(FormatNumber(Fix(MaxWorkingSetSize/1024),0,0,-2)) + " Kbytes)" + vbLF + _
             CStr(ScriptEZMain.ProbeMemoryStatus(1)) + vbLF + _
             CStr(ScriptEZMain.ProbeMemoryStatus(2)) + vbLF + _
             CStr(ScriptEZMain.ProbeMemoryStatus(6))

  Dim nSvc ' Number of running std services
  Dim WinVersion
  WinVersion  = ScriptEZMain.GetWindowsVersion
  If WinVersion=2000 Or WinVersion=90 Or WinVersion=40 Then
    Set colItems = objWMIService.ExecQuery("Select * from Win32_BaseService where state='running' and (servicetype='own process' or servicetype='share process')",,16)
  Else
    Set colItems = objWMIService.ExecQuery("Select * from Win32_BaseService where state='running' and servicetype like '%process%'",,16)
  End If
  nSvc = colItems.Count
  Set colItems = Nothing
  
  Dim nThread ' Number of active threads from within all processes and services
  Set colItems = objWMIService.ExecQuery("Select * from Win32_Thread",,16)
  nThread = colItems.Count
  Set colItems = Nothing

  Set colItems = objWMIService.ExecQuery("Select * from Win32_OperatingSystem",,48)
  For Each objItem in colItems
     LastBootUpTime = Mid(objItem.LastBootUpTime,1,14)
     TestData = TestData + vbLF + CStr(LastBootUpTime) + "\" + CStr(objItem.Caption) + vbLF + _
                CStr(objItem.NumberOfProcesses) + " (+" +CStr(nSvc) + ") over " + CStr(nThread) +" threads"
  Next
  Set colItems = Nothing

  If WinVersion=2000 Or WinVersion=90 Or WinVersion=40 Then
   Set colItems = objWMIService.ExecQuery("Select * from Win32_NetworkAdapter",,48)
  Else
   Set colItems = objWMIService.ExecQuery("Select * from Win32_NetworkAdapter where NetConnectionStatus >0 ",,48)
  End If
  Dim netWorkAdapters
  For Each objItem in colItems
    If Len(objItem.MACAddress) > 0 Then
     netWorkAdapters = netWorkAdapters + CStr(objItem.ProductName) + "[" + CStr(objItem.MACAddress) + "],"
	Else
	 netWorkAdapters = netWorkAdapters + CStr(objItem.ProductName) + "[n/a],"
	End If
  Next
  Set colItems = Nothing
  Set objWMIService = Nothing

  TestData = TestData + vbLF + CStr(Year(zDate))+zMonth+zDay+ " - " + CStr(ScriptEZMain.ProbeMemoryStatus(-1))
  TestData = TestData + vbLF + netWorkAdapters
  TestData = TestData + vbLF + ChkDriveSpace()
  TestData = TestData + vbLF + AGENT_VERSION

  ' Begin to send info array to remote server...
  Err_num = ScriptEZConnect.SendSocketObjectData( hSocket,TestData, Len(TestData) )
  If Err_num <> 0 Then
    ScriptEZMain_onRun = CLng(1) 
    Err_num = 0
    Exit Function
  End If  
  DisplayInfo()

End Function

Function CreateStartupShortcut()

  scriptfile = CStr(WScript.ScriptFullName)
  strSendTo = WshShell.SpecialFolders("Startup")

  On Error Resume Next
  Set fso = CreateObject("Scripting.FileSystemObject")
  fso.DeleteFile strSendTo & "\PCStats.lnk"
  Set fso= nothing

  set oShellLink = WshShell.CreateShortcut(strSendTo & "\PCStats.lnk")
  oShellLink.TargetPath = scriptfile
  oShellLink.WindowStyle = 1
  oShellLink.Description = "PCStats"
  oShellLink.WorkingDirectory = Mid(oShellLink.TargetPath,1,InStr(1,oShellLink.TargetPath,CStr(WScript.ScriptName))-1)
  oShellLink.Save
  set oShellLink = Nothing

End function

Function ChkDriveSpace()
   Dim fso, d, dc, s, n, f, t
   
   ChkDriveSpace = "n.a"
   on Error Resume Next
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set dc = fso.Drives
   For Each d in dc
    If d.IsReady  Then
      s = s & "[-" & d.DriveLetter & "-] " 
      s = s & Replace(CStr(Round(d.FreeSpace/1024000000,1)), ",", ".") & "/" 
	  s = s & Replace(CStr(Round(d.TotalSize/1024000000,1)),",",".") & " Go, "
	End If
   Next
   ChkDriveSpace = s
   Set fso=Nothing
End Function

Sub DisplayInfo()
  ReplyCount = ReplyCount + 1
  TotalSend = TotalSend + Len(TestData)

  ScriptEZMain.SetConsoleTitle CStr(StartTime) + " PC Stats Agent - sent_msg(" + _
                               CStr(ReplyCount) +")/" + InputString  
  ScriptEZConnect.PeekSocketClientObjectStatsOnReceivedData hSocket
  PendingTasks = ScriptEZMain.GetPendingTaskCount(hThreadPool)
  If ScrollOutput = 0 Then ScriptEZMain.ClearConsole
  Total = ScriptEZConnect.SocketSplittedPackets + _
          ScriptEZConnect.SocketOverlappedPackets + _
          ScriptEZConnect.SocketSimplePackets + _
          ScriptEZConnect.SocketWrongPackets
  If Total > 0 Then
   ScriptEZMain.Echo _
    " ." + CStr(Now) + vbLF+ " (WinSock version " + Socket_ver + ")" + vbLF + vbLF + _
    " Inbound..........:" + CStr(ScriptEZConnect.SocketObjectPendingInboundMessageCount(hSocket))+ _
                  " ("+CStr(Round(TotalRecv/1024,2))+" KBytes)"+vbLF + _ 
    " Outbound.........:" + CStr(ScriptEZConnect.SocketObjectPendingOutboundMessageCount(hSocket)) + _
                  " (" +CStr(Round(TotalSend/1024,2))+" KBytes)"+vbLF + _
    " Pending..........:" + CStr(PendingTasks) + vbLF + _
    vbLF + " ." + CStr(LastRecvTime) + vbLF + _
    " Splitted.........:" + CStr(ScriptEZConnect.SocketSplittedPackets) + _
                  " ("+CStr(Round((ScriptEZConnect.SocketSplittedPackets/Total)*100.0,2))+"%)"+vbLF+_
    " Overlapped.......:" + CStr(ScriptEZConnect.SocketOverlappedPackets) + _
                  " ("+CStr(Round((ScriptEZConnect.SocketOverlappedPackets/Total)*100.0,2))+"%)"+vbLF+_
    " Simple...........:" + CStr(ScriptEZConnect.SocketSimplePackets) + _
                  " ("+CStr(Round((ScriptEZConnect.SocketSimplePackets/Total)*100.0,2))+"%)"+vbLF+_
    " Wrong............:" + CStr(ScriptEZConnect.SocketWrongPackets) + vbLF +_
    " PooledThreadId...:" + CStr(ScriptEZMain.GetCurrentPooledThreadId) + vbLF
 End If
End Sub