'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . Memory Status Probing
' . Thread Pool usage
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Testing 
'//////////////////////////////////////////////////////////////////////////////
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name

Dim ScriptEZMain
Dim hThreadPool
Dim onExit 

' start the script
'/////////////////
'On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  onExit       = 0
  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If

  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZMain_")
  If Not IsObject(ScriptEZMain) Then Exit Sub

  'ScriptEZMain.SetCPUCoreAffinity "0"
 
  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZMain.AppRegister

  hThreadPool = ScriptEZMain.CreateTaskQueueObject(1)
  r = ScriptEZMain.AddTask( hThreadPool, 1000 )    

  ' block until socket break or exit event
  Do Until onExit = 3
      WScript.Sleep 1000
  Loop

  ' App unregister before ending
  ScriptEZMain.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZMain = Nothing

End Sub

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZMain_onAppEvent(EventID)

 ScriptEZMain.Echo " -> EventID:" + CStr(EventID)
 Select Case EventID
   Case 3  onExit= 3
 End Select

End Sub

Function ScriptEZMain_AppEventHelp()

 ScriptEZMain_AppEventHelp = vbLF +_
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF +_
       "AppEventID = 3" + vbTab + "to exit" + vbLF _
       )

End Function

' Callback for thread pool object (TaskQueueObject)
'//////////////////////////////////////////////////
Function ScriptEZMain_onRun( localStorage )

 battery_flag = ScriptEZMain.ProbeMemoryStatus(10)
 Select Case battery_flag
 case 1
     battery_status = "High (+66%)"
 case 2
     battery_status = "Low (-33%)"
 case 4
     battery_status = "Critical (-5%)"
 case 8
     battery_status = "Charging..."
 case 9
     battery_status = "High(+66%) - charging..."
 case 10
     battery_status = "Low(-33%) - charging..."
 case 12
     battery_status = "Critical(-5%) - charging..."
 case 128
     battery_status = "Direct Power"
 case 255
     battery_status = "Unknown"
 case else
     battery_status = "Between 33% and 66%"
 End Select
 
 WScript.Sleep localStorage 
 ScriptEZMain.ClearConsole
 ScriptEZMain.SetConsoleTitle "Memory Observer: " + CStr(ScriptEZMain.ProbeMemoryStatus(0)) + "% of memory is in use | battery charge: " + battery_status
 ScriptEZMain.Echo vbLF + " " + CStr(ScriptEZMain.ProbeMemoryStatus(0)) + "% of memory is in use"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(1),0,0,-2) + " Total Kbytes of physical memory"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(2),0,0,-2) + " Free  Kbytes of physical memory"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(3),0,0,-2) + " Total Kbytes of paging file"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(4),0,0,-2) + " Free  Kbytes of paging file"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(5),0,0,-2) + " Total Kbytes of virtual memory"
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(6),0,0,-2) + " Free  Kbytes of virtual memory" + vbLF
 ScriptEZMain.Echo vbLF + " " + FormatNumber(ScriptEZMain.ProbeMemoryStatus(7),0,0,-2) + " Kbytes in use by current process" 
 ScriptEZMain.Echo vbLF + " " + "Battery charge status: " + battery_status
 ScriptEZMain_onRun = CLng(1) ' run again this task
End Function
