'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . TCP/IP usage
' . Encryption
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Simple TCP/IP Client receiving Memory Status
'//////////////////////////////////////////////////////////////////////////////
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name

Dim ScriptEZMain
Dim hSocketClient
Dim StartTime
Dim Err_num
Dim onExit 
Dim InputString
Dim showRecvData
Dim Socket_ver
Dim bstrData
' start the script
'/////////////////
Main()

' Main Subroutine
'////////////////
Sub Main()

  Dim HostAndPort
  Dim hSocketClient

  showRecvData = 1
  onExit       = 0
  StartTime = Now()

  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If
  
  ' instantiate component object with callback interface
  Set ScriptEZMain = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZMain_")
  'ScriptEZMain.SetCPUCoreAffinity "0"

  ' create client socket object + xtra encryption
  hSocketClient = ScriptEZMain.CreateSocketClientObjectEx
  ScriptEZMain.EnableSocketObjectDataEncryption hSocketClient,true,-1 

  ' connect to server
  InputString = InputBox("Enter your hostname and port, such like localhost:12347", _
                         "Choose a hostname", _
                         "localhost:12347")
  If Len(InputString) <= 0 Then Exit Sub
  HostAndPort = Split(InputString,":")

  Err_num  = ScriptEZMain.ConnectSocketServerObject(HostAndPort(0), HostAndPort(1), hSocketClient)
  If Err_num <> 0 Then Exit Sub

  Socket_ver = ScriptEZMain.GetSocketObjectVersion(hSocketClient) 

  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZMain.AppRegister
  ScriptEZMain.SetConsoleTitle CStr(StartTime) + " (ScriptEZ.API) - TCP/IP Client " + InputString  

  ' block until socket break or exit event
  Do Until Err_num <> 0  Or onExit = 3
      WScript.Sleep 1000
  Loop

  ' empty queued msg for sending
  r = ScriptEZMain.SendSocketObjectData(hSocketClient,vbNullString,0)

  ' App unregister before ending
  ScriptEZMain.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZMain = Nothing

End Sub

Function DataHandler()

 If showRecvData = 1 Then ScriptEZMain.Echo vbLF + vbLF + " Today is :" + CStr(Now) + vbLF + bstrData
 DataHandler = CLng(0) 

End Function

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZMain_onAppEvent(EventID)

 ScriptEZMain.Echo " -> EventID:" + CStr(EventID)
 Select Case EventID
   Case 3  onExit= 3
   Case 0  showRecvData = 0
   Case 1  showRecvData = 1
 End Select

End Sub

Function ScriptEZMain_AppEventHelp()

 ScriptEZMain_AppEventHelp = vbLF +_
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF +_
       "AppEventID = 0" + vbTab + "to hide received data (default)" + vbLF +_
       "AppEventID = 1" + vbTab + "to display received data" + vbLF +_
       "AppEventID = 3" + vbTab + "to exit" + vbLF _
       )

End Function


' Callbacks for socket object 
' ( client/proxy side)
'///////////////////////////
Function ScriptEZMain_onConnectionState(hOwnerSocket,state_desc,error_number)

  ScriptEZMain.Echo state_desc
  Err_num =  error_number
  ScriptEZMain_onConnectionState = CLng(0)

End Function 

' ( client/proxy side)
'//////////////////////////
Function ScriptEZMain_onData(hOwnerSocket,raw_data,data_size)

  ' converting string to BSTR
  bstrData   = ScriptEZMain.ConvertStringToBSTR(raw_data)

  ' Handle this packet of data
  r = DataHandler()

  ScriptEZMain.FreeBSTR bstrData
  ScriptEZMain.FreeString raw_data
  ScriptEZMain_onData = CLng(0)

End Function 
