'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . TCP/IP usage
' . Encryption
' . Threadpool usage
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: TCP/IP Simple Server Probing Memory Status and Broadcasting to Clients
'//////////////////////////////////////////////////////////////////////////////
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name

Dim ScriptEZ
Dim hSocketSvr
Dim StartTime
Dim hThreadPool
Dim onExit
Dim showMemStatus
Dim enumerateClient
Dim MemStatus
' start the script
'////////////////
'On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  MemStatus = ""
  enumerateClient= 1
  showMemStatus  = 1
  onExit         = 0
  StartTime      = Now()

  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _ 
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If
 
  ' force to use MTA (Multi Threaded Apartment)
  WshShell.RegWrite "HKCR\CLSID\{01947673-ADB3-48F4-A162-CF06BB23CBCD}\InprocServer32\ThreadingModel", _
                    "Free", _
                    "REG_SZ"
   ' instantiate component object with callback interface
    Set ScriptEZ = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZ_")
    ScriptEZ.SetCPUCoreAffinity "0"
  ' force to use MTA (Multi Threaded Apartment)
  WshShell.RegWrite "HKCR\CLSID\{01947673-ADB3-48F4-A162-CF06BB23CBCD}\InprocServer32\ThreadingModel", _
                    "Both", _
                    "REG_SZ"

  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZ.AppRegister

  ' Hide console window if 0
  ScriptEZ.ShowConsoleWindow 1

  ' create server socket object +  extra  encryption
  hSocketSvr = ScriptEZ.CreatePoolSocketServerObject(12347,vbNullString,100,8,0,0)

  If hSocketSvr > 0 Then
    ScriptEZ.EnableSocketObjectDataEncryption hSocketSvr,true,-1 

    ' creating thread pool with 2 thread(s)
    hThreadPool = ScriptEZ.CreateTaskQueueObject(2)
    r = ScriptEZ.AddTask( hThreadPool,0)
    
    ' block until AppEventID = 3 is received
    Do Until onExit = 3
       WScript.Sleep 200
    Loop
  End If

  ScriptEZ.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZ = Nothing
End Sub

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZ_onAppEvent(EventID)

  If EventID = 3 Then onExit = EventID
   
  If EventID = 0 Then showMemStatus = EventID
  If EventID = 1 Then showMemStatus = EventID
  If EventID = 4 Then enumerateClient = 1
  If EventID = 5 Then enumerateClient = 0

End Sub

Function ScriptEZ_AppEventHelp()
 
 ScriptEZ_AppEventHelp = _ 
  CStr("  **** Supported AppEvents ****" + vbLF + _
       "AppEventID = 0" + vbTab + "to hide memory status" + vbLF + _
       "AppEventID = 1" + vbTab + "to display memory status (default)" + vbLF + _
       "AppEventID = 3" + vbTab + "to exit" + vbLF + _
       "AppEventID = 4" + vbTab + "to enumerate connected clients (default)" + vbLF + _
       "AppEventID = 5" + vbTab + "not to enumerate connected clients" + vbLF _ 
       )
End Function

' Callbacks for socket object 
' ( server side )
'///////////////////////////
Function ScriptEZ_onConnectionRequest(hSocketClientObjectProxy) 

 ScriptEZ_onConnectionRequest = CLng(ScriptEZ.AddSocketClientObjectEventHandlers(hSocketClientObjectProxy))
 ' delegating to the thread pool....
 r = ScriptEZ.AddTask( hThreadPool,hSocketClientObjectProxy )

End Function

' ( client/proxy side)
'/////////////////////
Function ScriptEZ_onConnectionState(hOwnerSocket,state_desc,error_number)

 ScriptEZ.Echo state_desc
 ScriptEZ_onConnectionState = CLng(0)

End Function 

' Callbacks for thread pool object (TaskQueueObject)
'//////////////////////////////////////////////////
Function ScriptEZ_onRun( hSocketClientProxy )

  WScript.Sleep 1000
  If onExit = 3 Then
    ' empty queued msg for sending
    r = ScriptEZ.SendSocketObjectData(hSocketClientProxy,vbNullString,0)
    ScriptEZ_onRun = CLng(0)
  Else
    ScriptEZ_onRun = CLng(1)
  End If

 
  If hSocketClientProxy > 0 Then
          Dim r
          inactivity = ScriptEZ.GetCurrentSessionUserInactivity
          MemStatus= vblf+"Server: "+ CStr(Date) + " " + CStr(Time) + vbLF + " " + CStr(ScriptEZ.ProbeMemoryStatus(0)) + "% of memory is in use" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(1),0,0,-2) + " Total Kbytes of physical memory" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(2),0,0,-2) + " Free  Kbytes of physical memory" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(3),0,0,-2) + " Total Kbytes of paging file" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(4),0,0,-2) + " Free  Kbytes of paging file" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(5),0,0,-2) + " Total Kbytes of virtual memory" + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(6),0,0,-2) + " Free  Kbytes of virtual memory" + vbLF + vbLF + _
                     " " + FormatNumber(ScriptEZ.ProbeMemoryStatus(7),0,0,-2) + " Kbytes of used memory by the server app" + vbLF + _
                     " User Inactivity for: " + CStr(inactivity) + " seconds" + vbLF
  
         Dim clientList
         clientList = vblf +"Client(s):" 
         Do While 1
         hSocketClient = ScriptEZ.EnumActiveSocketClientObject(hSocketSvr)
         If hSocketClient <= 0 Then
            Exit Do
         End If

         zClient = ScriptEZ.GetSocketConnectedClientName(hSocketClient)
         clientList = clientList +  vbLF + _
                CStr(zClient) + _ 
                " Inbound:" + CStr(ScriptEZ.SocketObjectPendingInboundMessageCount(hSocketClient)) + _
                " Outbound:" + CStr(ScriptEZ.SocketObjectPendingOutboundMessageCount(hSocketClient))
         ScriptEZ.FreeBSTR zClient
        Loop
      MemStatus = Replace(MemStatus,Chr(182),Chr(20)) + clientList
      r = ScriptEZ.SendSocketObjectData( hSocketClientProxy,MemStatus, Len(MemStatus) )
      if r <> 0 Then ScriptEZ_onRun = CLng(0)

  Else
     ScriptEZ.SetConsoleTitle CStr(StartTime) + " (ScriptEZ.API) - Memory Status TCP/IP Server@12347" 
     ScriptEZ.ClearConsole
     If Len(MemStatus) > 0 Then ScriptEZ.Echo MemStatus
  End If
  
End Function
