'//////////////////////////////////////////////////////////////////////////////
' Author: SY
' Demo ScriptEZ.API based application which uses facilities from RAD API:
' . TCP/IP usage
' . Threadpool usage
' . Echo() method usage which displays always messages into a console window
'   instead of WScript.Echo() with 2 behaviours for cscript.exe or wscript.exe
' . SQlite API usage
' . String and BSTR usage
' . ScriptEZ.API Remoting Control Interface usage by NPTelnet.exe program
'   (Connect to ScriptEZ.API process with <processid (PID)> as connection name)
'
' Purpose: Simple TCP/IP Server receiving and updating PC Stats into db file
'//////////////////////////////////////////////////////////////////////////////

const SrvPort      = 80
const SCRIPTEZ_API = "ScriptEZ.API" ' Component name
const PROBING_DELAY_LBL = "PROBING_DELAY:"
const PROBING_DELAY= 8000           ' Forwards this delay in ms to each client

Dim InboundDataDico ' Scripting.Dictionary object
Dim ScriptEZ
Dim ScriptEZConsole
Dim hSocketSvr
Dim StartTime
Dim TotalRecv
Dim TotalRecvPrev
Dim TotalMinRecv
Dim TotalMaxRecv
Dim hThreadPool
Dim hThreadPoolConsole
Dim onExit
Dim showRecvData
Dim enumerateClient
Dim useNonBlocking
Dim hSQLite
Dim currDate
Dim dataReceived
Dim sendServerTime
Dim firstRequest
Dim vacuumThreshHold
' start the script
'////////////////
On Error Resume Next
Main()

' Main Subroutine
'////////////////
Sub Main()

  vacuumThreshHold = 0
  firstRequest = 0
  dataReceived = 0
  useNonBlocking = 1
  hSQLite      = 0
  enumerateClient= 0
  showRecvData = 0
  onExit       = 0
  TotalRecv    = 0
  TotalRecvPrev= 0
  TotalMinRecv = 1000000000
  TotalMaxRecv = 0
  sendServerTime = 0

  StartTime    = Now()

  Dim zDate, zMonth, zDay
  zDate = Date()
  zMonth = CStr(Month(zDate))
  If Len(zMonth) < 2 Then zMonth = "0" +zMonth
  zDay = CStr(Day(zDate))
  If Len(zDay) < 2 Then zDay = "0" +zDay

  currDate = CLng(CStr(Year(zDate))+zMonth+zDay)

  Set InboundDataDico = CreateObject("Scripting.Dictionary")
  Set WshShell = CreateObject("WScript.Shell")
  Set fso      = CreateObject("Scripting.FileSystemObject")
  
  Dim Windir
  Dim FullQualifiedEngineName
  ' if Win64, restart with WScript.exe/CScript.exe 32 bits
  On Error Resume Next
  Windir = WshShell.ExpandEnvironmentStrings("%WinDir%")
  FullQualifiedEngineName = Windir+"\SysWOW64" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))
  If fso.FolderExists(Windir+"\SysWOW64") And _ 
     LCase(WScript.FullName) <>  LCase(FullQualifiedEngineName) And _
     LCase(WScript.FullName) = LCase(Windir+"\System32" + Mid(WScript.FullName,InStrRev(WScript.FullName,"\"),Len(WScript.FullName))) And _
     fso.FileExists(FullQualifiedEngineName) = True Then
    WshShell.Run FullQualifiedEngineName + " " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34)
    Exit Sub
  End If

  ' instantiate component object with callback interface
  Set ScriptEZ = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZ_")
  Set ScriptEZConsole = WScript.CreateObject(SCRIPTEZ_API,"ScriptEZConsole_")
  'ScriptEZ.SetCPUCoreAffinity "0"

  ' Register App for receiving AppEvent(s) with onAppEvent(EventID)
  ScriptEZ.AppRegister
  ScriptEZConsole.AppRegister

   ' Hide console window if 0
  ScriptEZ.ShowConsoleWindow 1

    hSQLite = ScriptEZ.CreateSQLiteDBObject("c:\eDashBoard.ldb")
    ScriptEZ.SetSQLiteDBObjectCommitTimeout hSQLite, 8
    n=ScriptEZ.SQLite_execDML(hSQLite,"CREATE TABLE IF NOT EXISTS TConnection(" + _
                                      "[DATE] Text," + _
                                      "[CONNECTED_CLIENT] Text," + _
                                      "[BEGIN_TIME] Text," + _
                                      "[END_TIME] Text," + _
                                      "[UPDATE_TIME] Text," + _
                                      "[INBOUND_KBYTES] Text," + _
                                      "[OUTBOUND_KBYTES] Text);")

    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [CURRENT_USER_NAME] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [COMPUTER_NAME] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [IN_USE_MEMORY] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [PHYSICAL_MEMORY] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [FREE_PHYSICAL_MEMORY] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [FREE_VIRTUAL_MEMORY] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [LASTBOOTUPTIME] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [NUMBER_OF_PROCESSES] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [REFRESH_DATE] Text;")
    n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [NETWORK_ADAPTERS] Text;")
	n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [DRIVES_FREESPACE] Text;")
	n=ScriptEZ.SQLite_execDML(hSQLite,"ALTER TABLE TConnection ADD COLUMN [AGENT_VERSION] Text;")

  ' create server socket object +  extra  encryption
  hSocketSvr = ScriptEZ.CreatePoolSocketServerObject(SrvPort,vbNullString,1024,8,0,0)

  If hSocketSvr > 0 Then
    ScriptEZ.EnableSocketObjectDataEncryption hSocketSvr,true,-1 
    ' limit inactivity timeout for  ~ 1 mn
    ScriptEZ.SetPoolSocketServerObjectInactivityTimeout hSocketSvr, 1


    ' creating thread pool with 4 threads
    hThreadPool = ScriptEZ.CreateTaskQueueObject(4)
    
    hThreadPoolConsole = ScriptEZConsole.CreateTaskQueueObject(1)
    r = ScriptEZConsole.AddTask( hThreadPoolConsole,0)

    ' block until AppEventID = 3 is received
    Do Until onExit = 3
       WScript.Sleep 1000
    Loop
  End If

  ScriptEZ.DestroySQLiteDBObject hSQLite
  ScriptEZ.AppUnregister
  ScriptEZConsole.AppUnregister
  WScript.Sleep 4000
  Set ScriptEZ = Nothing
  Set ScriptEZConsole = Nothing
  Set InboundDataDico = Nothing
End Sub

' Callbacks for App Events notification and fetching help text
'/////////////////////////////////////////////////////////////
Sub ScriptEZ_onAppEvent(EventID)

  Select Case EventID
   Case 3  onExit = 3
           ScriptEZ.Terminate 0
   Case 0  showRecvData = 0
   Case 1  showRecvData = 1
   Case 4  enumerateClient = 1
   Case -4 enumerateClient = 0
   Case 7  useNonBlocking = 0
   Case -7 useNonBlocking = 1
   Case 8  sendServerTime = 1
   Case -8 sendServerTime = 0
  End Select

End Sub

Function ScriptEZ_AppEventHelp()
 
 ScriptEZ_AppEventHelp = _ 
  CStr("Filename: " + Chr(34) + CStr(WScript.ScriptFullName) + Chr(34) + vbLF +_
       "  **** Supported AppEvents ****" + vbLF + _
       "AppEventID = 3     " + vbTab + "to exit" + vbLF + _
       "AppEventID = 0 or 1" + vbTab + "to hide received data (default) or to display received data" + vbLF + _
       "AppEventID = 4 or -4" + vbTab + "to enumerate connected clients or not to enumerate connected clients (default)" + vbLF + _
       "AppEventID = 7 or -7" + vbTab + "to use nonblocking socket (default) or to use blocking socket" + vbLF +_
       "AppEventID = 8 or -8" + vbTab + "to broadcast server's time or no broadcast (default)"  _
       )
 If enumerateClient = 0 And TotalMinRecv <> 1000000000 Then
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp + vbLF + vbLF + ". Current Stats:"
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + "Received......: " +_
                  CStr(Round(CDbl(TotalRecv/1024.0),2)) + " KBytes" +_
                  vbLF + "Delta Received: " + _
                  CStr(Round(CDbl(TotalRecv-TotalRecvPrev)/1024.0,2)) + " KBytes" +_
                  vbLF + "Delta Max.....: " + _
                  CStr(TotalMaxRecv) + " Bytes" +_
                  vbLF + "Delta Min.....: " + _
                  CStr(TotalMinRecv) + " Bytes"
 End If

 ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp + vbLF + vbLF + ". Current Configuration:"
 If showRecvData = 0 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (1) hide received data (default)"

 If showRecvData = 1 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (1) show received data"

 If enumerateClient = 0 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (2) not to enumerate connected clients (default)"
                  
 If enumerateClient = 1 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (2) to enumerate connected clients"

 If useNonBlocking = 0 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (3) use blocking socket"

 If useNonBlocking = 1 Then  _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (3) use nonblocking socket (default)"

 If sendServerTime = 1 Then _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (4) broadcast server's time"

 If sendServerTime = 0 Then _
   ScriptEZ_AppEventHelp = ScriptEZ_AppEventHelp +_
                  vbLF + " (4) no broadcast server's time (default)"

End Function

Sub AddNewRow(hSocketClientObjectProxy, HostAndPort)

 Dim zDate, zMonth, zDay
 zDate = Date()
 
 Dim hStringValueTable
 hStringValueTable = ScriptEZ.MallocStringTable(19)
 zMonth = CStr(Month(zDate))
 If Len(zMonth) < 2 Then zMonth = "0" +zMonth
 zDay = CStr(Day(zDate))
 If Len(zDay) < 2 Then zDay = "0" +zDay

 r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Year(zDate))+zMonth+zDay )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, HostAndPort(0)+":"+HostAndPort(1) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Time()) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 
 Dim sqlInsertCmd
 sqlInsertCmd = ScriptEZ.SQLite_buildInsertCommand("TConnection",hStringValueTable) 
 'ScriptEZ.Echo sqlInsertCmd
 n = ScriptEZ.SQLite_execDML(hSQLite,sqlInsertCmd)

 ScriptEZ.FreeBSTR sqlInsertCmd
 ScriptEZ.FreeStringTable hStringValueTable

End Sub
' Callbacks for socket object 
' ( server side )
'///////////////////////////
Function ScriptEZ_onConnectionRequest(hSocketClientObjectProxy) 

 ScriptEZ.Echo "Connection Requested(" + CStr(hSocketClientObjectProxy) + ")"
 If hSQLite = 0 Then
   ScriptEZ_onConnectionRequest = CLng(0)
   firstRequest = 1
   Exit Function
 End If

 
 r = ScriptEZ.EnableSocketObjectNonBlockingModeUsage(hSocketClientObjectProxy,useNonBlocking)
 ScriptEZ_onConnectionRequest = CLng(ScriptEZ.AddSocketClientObjectEventHandlers(hSocketClientObjectProxy))
 ' delegating to the thread pool....
  r = ScriptEZ.SetSocketObjectLocalStorage(hSocketClientObjectProxy,0)
  r = ScriptEZ.AddTask( hThreadPool,hSocketClientObjectProxy )

 ScriptEZ.Echo "Connection Accepted(" + CStr(ScriptEZ_onConnectionRequest) + ")"

End Function

' ( client/proxy side)
'/////////////////////
Function ScriptEZ_onConnectionState(hOwnerSocket,state_desc,error_number)

 Dim zClient, HostAndPort, hStringFieldTable, hStringValueTable, zWhere
 Dim r, sqlUpdateCmd

 ScriptEZ.Echo state_desc
 zClient = ScriptEZ.GetSocketConnectedClientName(hOwnerSocket)
 HostAndPort = Split(zClient,":")
 ScriptEZ.FreeBSTR zClient

 Dim zDate, zMonth, zDay
 zDate = Date()
 zMonth = CStr(Month(zDate))
 If Len(zMonth) < 2 Then zMonth = "0" +zMonth
 zDay = CStr(Day(zDate))
 If Len(zDay) < 2 Then zDay = "0" +zDay

 zWhere = "WHERE CONNECTED_CLIENT='" + HostAndPort(0) + ":" + HostAndPort(1) + "'" + _
          "AND DATE='" + CStr(Year(zDate))+zMonth+zDay + "'"

 hStringFieldTable = ScriptEZ.MallocStringTable(1)
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "END_TIME" )

 hStringValueTable = ScriptEZ.MallocStringTable(1)
 r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Time()) )

 Dim zKey
 zKey = HostAndPort(0)+":"+HostAndPort(1) + "_" + CStr(Year(zDate))+zMonth+zDay
 If InboundDataDico.Exists(zKey) Then
   InboundDataDico.Remove(zKey)
 End If


 sqlUpdateCmd = ScriptEZ.SQLite_buildUpdateCommand("TConnection",hStringFieldTable,hStringValueTable,zWhere) 
 r = ScriptEZ.SQLite_execDML(hSQLite,sqlUpdateCmd)
 
 ScriptEZ.FreeBSTR sqlUpdateCmd
 ScriptEZ.FreeStringTable hStringFieldTable
 ScriptEZ.FreeStringTable hStringValueTable
 ScriptEZ_onConnectionState = CLng(0)

End Function 

' ( client/proxy side)
'/////////////////////
Function ScriptEZ_onData(hOwnerSocket,raw_data,data_size)

 Dim bstrData,inBoundSize, sqlUpdateCmd
 Dim r, zClient, HostAndPort
 Dim zWhere, hStringFieldTable, hStringValueTable 
 Dim Pc_Stats

 TotalRecv = TotalRecv + data_size
 bstrData = ScriptEZ.ConvertStringToBSTR(raw_data)
 If showRecvData = 1 Then
   ScriptEZ.Echo CStr(Now)  + " size(" + CStr(data_size) + ") " + CStr(bstrData)
 End If

 ' Splitting data info into array of string
 Pc_Stats = Split(bstrData,CStr(vbLF))

 ScriptEZ.FreeBSTR bstrData
 ScriptEZ.FreeString raw_data

 ' bad data array
 If UBound(Pc_Stats,1) < 7 Then
   ScriptEZ_onData = CLng(0)
   Exit Function
 End If

 zClient = ScriptEZ.GetSocketConnectedClientName(hOwnerSocket)
 HostAndPort = Split(zClient,":")
 ScriptEZ.FreeBSTR zClient

 Dim zDate, zMonth, zDay
 zDate = Date()
 zMonth = CStr(Month(zDate))
 If Len(zMonth) < 2 Then zMonth = "0" +zMonth
 zDay = CStr(Day(zDate))
 If Len(zDay) < 2 Then zDay = "0" +zDay

 Dim zKey
 zKey = HostAndPort(0)+":"+HostAndPort(1) + "_" + CStr(Year(zDate))+zMonth+zDay
 If Not InboundDataDico.Exists(zKey) Then
   ScriptEZ_onData = CLng(0)
   Exit Function
 End If
 

 inBoundSize = InboundDataDico.Item(HostAndPort(0)+":"+HostAndPort(1)) + data_size
 InboundDataDico.Remove( HostAndPort(0)+":"+HostAndPort(1) )
 InboundDataDico.Add HostAndPort(0)+":"+HostAndPort(1),inBoundSize


 zWhere = "WHERE CONNECTED_CLIENT='" + CStr(HostAndPort(0)) +":" + CStr(HostAndPort(1)) + "'" + _
          "AND DATE='" + CStr(Year(zDate))+zMonth+zDay + "'"

 hStringFieldTable = ScriptEZ.MallocStringTable(14)
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "INBOUND_KBYTES" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "UPDATE_TIME" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "COMPUTER_NAME" ) 
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "CURRENT_USER_NAME" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "IN_USE_MEMORY" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "PHYSICAL_MEMORY" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "FREE_PHYSICAL_MEMORY" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "FREE_VIRTUAL_MEMORY" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "LASTBOOTUPTIME" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "NUMBER_OF_PROCESSES" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "REFRESH_DATE" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "NETWORK_ADAPTERS" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "DRIVES_FREESPACE" )
 r = ScriptEZ.AddStringTableItem(hStringFieldTable, "AGENT_VERSION" )

 hStringValueTable = ScriptEZ.MallocStringTable(14)
 r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Round(CDbl(inBoundSize/1024.0),2)) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Time()) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(0) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(1) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(2) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(3) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(4) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(5) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(6) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(7) )
 r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(8) )
 
 If UBound(Pc_Stats,1) >= 9 Then
   r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(9) )
   Select Case UBound(Pc_Stats,1)
    Case 10    r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(10) )
    Case 11    r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(10) )
	           r = ScriptEZ.AddStringTableItem(hStringValueTable, Pc_Stats(11) )
    'Other cases here if new elements will be sent by new agent script
   End Select
 Else
   r = ScriptEZ.AddStringTableItem(hStringValueTable, "_" )
 End If

 sqlUpdateCmd = ScriptEZ.SQLite_buildUpdateCommand("TConnection",hStringFieldTable,hStringValueTable,zWhere) 
 r = ScriptEZ.SQLite_execDML(hSQLite,sqlUpdateCmd)

 ScriptEZ.FreeBSTR sqlUpdateCmd
 ScriptEZ.FreeStringTable hStringFieldTable
 ScriptEZ.FreeStringTable hStringValueTable
 ScriptEZ_onData = CLng(0)
 dataReceived = 1

End Function 

' Callbacks for thread pool object (TaskQueueObject)
'//////////////////////////////////////////////////
Function ScriptEZ_onRun( hSocketClientProxy )

  ' Send server's time
  WScript.Sleep 3000
  If dataReceived = 0 Then
    If onExit = 3 Then 
      ScriptEZ_onRun = CLng(0)
      Exit Function
    Else
      ScriptEZ_onRun = CLng(1)
     End If
  End If
  thisTime = Now()

  If sendServerTime = 1 Then
   r = ScriptEZ.SendSocketObjectData( hSocketClientProxy,thisTime, Len(thisTime) )
   If r <> 0 Then
    ScriptEZ_onRun = CLng(0)
    Exit Function
   End If
  End IF

  dataReceived = 0
  Dim HostAndPort, zClient, zWhere, r
  Dim hStringFieldTable, hStringValueTable
  Dim sqlUpdateCmd, total_size, data_size

  data_size = 0
  If sendServerTime = 1 Then data_size = Len(thisTime)   
  zClient = ScriptEZ.GetSocketConnectedClientName(hSocketClientProxy)
  If Len(zClient) <= 0 Then
    ScriptEZ_onRun = CLng(0)
    Exit Function
  End If
  HostAndPort = Split(zClient,":")
  ScriptEZ.FreeBSTR zClient

  Dim zDate, zMonth, zDay
  zDate = Date()
  zMonth = CStr(Month(zDate))
  If Len(zMonth) < 2 Then zMonth = "0" +zMonth
  zDay = CStr(Day(zDate))
  If Len(zDay) < 2 Then zDay = "0" +zDay
  
  Dim zKey
  zKey = HostAndPort(0)+":"+HostAndPort(1) + "_" + CStr(Year(zDate))+zMonth+zDay
  If Not InboundDataDico.Exists(zKey) Then
    InboundDataDico.Add zKey, 1
    ' insert a new row into SQLite table
    AddNewRow hSocketClientProxy, HostAndPort
	Dim custom_delay
	custom_delay = PROBING_DELAY_LBL & CStr(PROBING_DELAY)
    r = ScriptEZ.SendSocketObjectData( hSocketClientProxy,custom_delay, Len(custom_delay) )
    If r <> 0 Then
     ScriptEZ_onRun = CLng(0)
     Exit Function
    End If	
    ' reset variables for a new day
    r = ScriptEZ.SetSocketObjectLocalStorage(hSocketClientProxy,0)
    If InboundDataDico.Exists(HostAndPort(0)+":"+HostAndPort(1))  Then
      InboundDataDico.Remove( HostAndPort(0)+":"+HostAndPort(1) )
    End If
    InboundDataDico.Add HostAndPort(0)+":"+HostAndPort(1),0
  End If
  zWhere = "WHERE CONNECTED_CLIENT='" + CStr(HostAndPort(0)) +":" + CStr(HostAndPort(1)) + "'" + _
           "AND DATE='" + CStr(Year(zDate))+zMonth+zDay + "'"

  hStringFieldTable = ScriptEZ.MallocStringTable(2)
  r = ScriptEZ.AddStringTableItem(hStringFieldTable, "OUTBOUND_KBYTES" )
  r = ScriptEZ.AddStringTableItem(hStringFieldTable, "UPDATE_TIME" )

  hStringValueTable = ScriptEZ.MallocStringTable(2)
  total_size = ScriptEZ.GetSocketObjectLocalStorage(hSocketClientProxy)
  total_size = total_size + data_size
  r = ScriptEZ.SetSocketObjectLocalStorage(hSocketClientProxy,total_size)
  r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Round(CDbl(total_size/1024.0),2)) )
  r = ScriptEZ.AddStringTableItem(hStringValueTable, CStr(Time()) )

  sqlUpdateCmd = ScriptEZ.SQLite_buildUpdateCommand("TConnection",hStringFieldTable,hStringValueTable,zWhere) 
  r = ScriptEZ.SQLite_execDML(hSQLite,sqlUpdateCmd)

  ScriptEZ.FreeBSTR sqlUpdateCmd
  ScriptEZ.FreeStringTable hStringFieldTable
  ScriptEZ.FreeStringTable hStringValueTable
  
  If onExit = 3 Then 
    ScriptEZ_onRun = CLng(0)
  Else
    ScriptEZ_onRun = CLng(1)
  End If

End Function

' Notification on Task aborting
'//////////////////////////////
Sub ScriptEZ_onAbort( hSocketClientProxy )
End Sub

Function ScriptEZConsole_onRun( localStorage )

 Dim zClient

 ScriptEZ.SetConsoleTitle CStr(StartTime) + " PC Stats Server@" + CStr(SrvPort) 
 WScript.Sleep 1000
 ScriptEZ.ClearConsole

 vacuumThreshHold = vacuumThreshHold + 1
 ' Cleansing and shrinking database every 30 minutes
 If vacuumThreshHold = 1800 Then
    ' Get rid of odd connections (unknown clients)
    r = ScriptEZ.SQLite_execDML(hSQLite,"DELETE FROM TConnection WHERE COMPUTER_NAME ='_' COLLATE NOCASE;")
	r = ScriptEZ.SQLite_execDML(hSQLite,"VACUUM;")
	ScriptEZ.Echo "Cleansing eDashBoard Database: " + CStr(r)
	vacuumThreshHold = 0
 End IF

 If (TotalRecv-TotalRecvPrev) < TotalMinRecv And (TotalRecv-TotalRecvPrev) > 0 Then
    TotalMinRecv = (TotalRecv-TotalRecvPrev)
 End If

 If (TotalRecv-TotalRecvPrev) > TotalMaxRecv Then
   TotalMaxRecv = (TotalRecv-TotalRecvPrev)
 End If
 If enumerateClient = 0 And TotalMinRecv <> 1000000000 Then
   ScriptEZ.Echo  vbLF + " Received......: " +_
                  CStr(Round(CDbl(TotalRecv/1024.0),2)) + " KBytes" +_
                  vbLF + " Delta Received: " + _
                  CStr(Round(CDbl(TotalRecv-TotalRecvPrev)/1024.0,2)) + " KBytes" +_
                  vbLF + " Delta Max.....: " + _
                  CStr(TotalMaxRecv) + " Bytes" +_
                  vbLF + " Delta Min.....: " + _
                  CStr(TotalMinRecv) + " Bytes"
 End If

 TotalRecvPrev = TotalRecv

 If enumerateClient = 1 Then
    ScriptEZ.Echo  vbLF + " Clients:" + _
                  CStr(ScriptEZ.GetActiveSocketClientObjectNumber(hSocketSvr))+" Received: " + _
                  CStr(Round(CDbl(TotalRecv/1024.0),2))+" KBytes"
    Do While 1
     hSocketClientProxy = ScriptEZ.EnumActiveSocketClientObject(hSocketSvr)
     If hSocketClientProxy <= 0 Then
        Exit Do
     End If
     zClient = ScriptEZ.GetSocketConnectedClientName(hSocketClientProxy)
     ScriptEZ.Echo  _
            CStr(zClient) + _ 
            " Inbound:" + CStr(ScriptEZ.SocketObjectPendingInboundMessageCount(hSocketClientProxy)) + _
            " Outbound:" + CStr(ScriptEZ.SocketObjectPendingOutboundMessageCount(hSocketClientProxy))
     ScriptEZ.FreeBSTR zClient
    Loop
    If ScriptEZ.GetActiveSocketClientObjectNumber(hSocketSvr) = 0 Then TotalRecv = 0 
 End If

 If onExit = 3 Then 
   ScriptEZConsole_onRun = CLng(0)
 Else
   ScriptEZConsole_onRun = CLng(1)
 End If

End Function

